`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    06:58:04 02/05/2009 
// Design Name: 
// Module Name:    edc 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module edc(
    input clk,
    input n_strobe,
    input reset,
    input [15:0] addr,
    input [31:0] w_data,
    input [3:0] we_byte,
    input [3:0] test_ctrl,
    input lrb_test,
    input [11:0] htr_buf_addr,
    input [8:0] htr_buf_length,
    input htr_buf_req,
    input [4:0] event_data_rdy,
    input [32:0] lrb0_event_data,
    input [32:0] lrb1_event_data,
    input [32:0] lrb2_event_data,
    input [32:0] lrb3_event_data,
    input [32:0] lrb4_event_data,
    input [4:0] event_info_val,
    input [4:0] event_info_rdy,
    input [32:0] lrb0_event_info,
    input [32:0] lrb1_event_info,
    input [32:0] lrb2_event_info,
    input [32:0] lrb3_event_info,
    input [32:0] lrb4_event_info,
    input event_buf_afull,
    input [4:0] lrb_ack,
    input [3:0] htr_rd_cnt,
    input [3:0] rp_addr,
    input [8:0] rp,
    output reg [3:0] wp_addr,
    output reg [8:0] dpo_wp,
    output reg [14:0] htr_buf_ovf,
    input htr_rd_cnt_str,
    output reg [4:0] re_event_data =5'b0,
    output reg [4:0] rd_next_event =5'b0,
    output reg [4:0] re_event_info = 5'b0,
    output reg [4:0] event_data_req_str = 5'b0,
    output reg [18:0] event_data_req,
    output reg event_data_val = 1'b0,
    output [32:0] event_data,
    output lrb_test_str,
    output [31:0] lrb_test_data,
    output [31:0] debug,
		input [11:0] evn_ra,
		input [11:0] smry_ra,
    output [31:0] summary,
    output [40:0] lrb_evn,
    input [14:0] debug_addr,
    input [14:0] counter_addr,
    output [31:0] counters, 
    output [31:0] htr_state_LUT, 
    output HTR_ow, 
    output HTR_bz, 
    output [1:0] HTR_state
    );
reg eoe = 1'b0;
reg [4:0] lrb_err = 5'b0;
reg [47:0] lfsr_cntr = 40'b0;
reg [31:0] lfsr = 32'b0;
reg ec_lfsr = 1'b0;
reg strobe = 1'b0;
reg [4:0] lrb_ack_l = 5'b0;
reg [32:0] lrb_event_data = 33'b0;
reg [32:0] d_info_fifo = 33'b0;
wire [4:0] lrb_ch; 
	assign lrb_test_str = ec_lfsr;
//	assign lrb_test_data = lfsr_cntr[31:0];
	assign lrb_test_data = lfsr;
	assign event_data = {eoe,lrb_event_data[31:0]};
	always @(posedge clk)
		strobe <= n_strobe && ~strobe;
	always @(posedge clk)
		lrb_event_data <= lrb0_event_data | lrb1_event_data | lrb2_event_data | lrb3_event_data | lrb4_event_data;
	always @(posedge clk)
		if(strobe == 1'b1) begin
			if(lrb_test == 1'b0)
				lfsr <= 32'h0;
			else if(ec_lfsr == 1'b1)
				lfsr <= {lfsr[30:0],~(lfsr[31]^lfsr[21]^lfsr[1]^lfsr[0])};
			if(lrb_test == 1'b0 || ec_lfsr == 1'b1 || lfsr_cntr[test_ctrl+32] == 1'b1 || lrb_err != 5'b0)
				ec_lfsr <= 1'b0;
			else if(lrb_ack_l == 5'h1f)
				ec_lfsr <= 1'b1;
			if(lrb_test == 1'b0)
				lfsr_cntr <= 48'h0;
			else if(ec_lfsr == 1'b1)
				lfsr_cntr <= lfsr_cntr + 1;
			if(lrb_test == 1'b0)
				lrb_ack_l <= 5'h1f;
			else if(ec_lfsr == 1'b1)
				lrb_ack_l <= 5'b0;
			else
				lrb_ack_l <= lrb_ack_l | lrb_ack;
			if (lrb_test == 1'b0)
				event_data_req <= {lrb_ch[1:0], htr_buf_addr[7:0], htr_buf_length[8:0]};
			else
				event_data_req <= {lfsr_cntr[18:9], 9'h1ff};
			if(lrb_test == 1'b1) begin
				if(lfsr_cntr[8:0] == 9'h1ff && ec_lfsr == 1'b1)
					event_data_req_str <= 5'h1f;
				else
					event_data_req_str <= 5'h0;
			end else if(htr_buf_req == 1'b0)
				event_data_req_str <= 5'h0;
			else begin
				case (lrb_ch[4:2])
					3'b000 : event_data_req_str[0] <= 1'b1;
					3'b001 : event_data_req_str[1] <= 1'b1;
					3'b010 : event_data_req_str[2] <= 1'b1;
					3'b011 : event_data_req_str[3] <= 1'b1;
					3'b100 : event_data_req_str[4] <= 1'b1;
					default : event_data_req_str <= 5'h0;
				endcase
			end
		end
reg [15:0] htr_buf_que_in = 16'b0;
reg [15:0] htr_buf_cntr = 16'b0;
reg [15:0] max_htr_buf = 16'b0;
reg we_htr_buf_que = 1'b0;
wire dav_htr_buf_que;
reg re_htr_buf_que = 1'b0;
reg ofw_htr_buf_que = 1'b0;
wire [15:0] htr_buf_que_out;
wire [4:0] rp_htr_buf_que;
	always @(posedge clk)
		if(strobe == 1'b1 && reset == 1)
			htr_buf_cntr <= 16'h0;
		else if(re_htr_buf_que != (strobe && we_htr_buf_que)) begin
			if(re_htr_buf_que == 1)
				htr_buf_cntr <= htr_buf_cntr - 1;
			else
				htr_buf_cntr <= htr_buf_cntr + 1;
		end
	always @(posedge clk)
		if(reset == 1)
			max_htr_buf <= 16'h0;
		else if(htr_buf_cntr > max_htr_buf)
			max_htr_buf <= htr_buf_cntr + 1;
	always @(posedge clk)
		if(strobe == 1'b1)
			if(lrb_test == 1'b1) begin
				htr_buf_que_in <= {4'b0, lfsr_cntr[2:0], 9'h1ff};
				if(ec_lfsr == 1'b1 && lfsr_cntr[8:3] == 6'h3f && (lfsr_cntr[2] == 1'b0 || lfsr_cntr[1:0] == 2'b0))
					we_htr_buf_que <= 1'b1;
				else
					we_htr_buf_que <= 1'b0;
			end else begin
				htr_buf_que_in <= {htr_buf_addr[11:8], lrb_ch[4:2], htr_buf_length[8:0]};
				we_htr_buf_que <= htr_buf_req;
			end
	always @(posedge clk)
		if(strobe == 1'b1)
			if(reset == 1'b1)
				ofw_htr_buf_que <= 0;
			else if(we_htr_buf_que == 1 && rp_htr_buf_que == 5'h1e)
				ofw_htr_buf_que <= 1;
srl_fifo32 #(.N(16))i_htr_buf_que (
    .rst(reset), 
    .din(htr_buf_que_in), 
		.w_strobe(strobe),
    .we(we_htr_buf_que), 
    .clk(clk), 
		.r_strobe(1'b1),
    .re(re_htr_buf_que), 
    .dout(htr_buf_que_out),
		.dav(dav_htr_buf_que),
    .rp(rp_htr_buf_que)
    );
reg rd_idle = 1;
reg [4:0] rd_event_data = 5'b0;
reg [8:0] rd_wc = 9'b0;
reg rd_evt_data = 1'b0;
reg [4:0] htr_rd_cntr = 5'b0;
reg cntr_que_afull = 1'b0;
	always @(posedge clk)
		if(reset == 1'b1)
			re_htr_buf_que <= 1'b0;
		else if(dav_htr_buf_que == 1'b1 && rd_event_data == 5'b0 && cntr_que_afull == 1'b0 && (htr_rd_cntr[4] == 1'b1 || lrb_test == 1'b1))
			case (htr_buf_que_out[11:9])
				3'b000 : re_htr_buf_que <= event_data_rdy[0];
				3'b001 : re_htr_buf_que <= event_data_rdy[1];
				3'b010 : re_htr_buf_que <= event_data_rdy[2];
				3'b011 : re_htr_buf_que <= event_data_rdy[3];
				default : re_htr_buf_que <= event_data_rdy[4];
			endcase
		else
			re_htr_buf_que <= 1'b0;
	always @(posedge clk)
		if(rd_event_data == 5'b0)
			rd_wc <= ~htr_buf_que_out[8:0];
		else if(event_buf_afull == 1'b0)
			rd_wc <= rd_wc + 1;
	always @(posedge clk)
		if(reset == 1'b1 || rd_event_data == 5'b0 || event_buf_afull == 1'b1)
			rd_evt_data <= 1'b0;
		else
			rd_evt_data <= 1'b1;
	always @(posedge clk)
		if(rd_event_data == 5'b0)
			rd_idle <= 1;
		else
			rd_idle <= 0;
	always @(posedge clk)
		if(rd_idle == 1)
			rd_next_event <= rd_event_data;
		else
			rd_next_event <= 5'b0;
	always @(posedge clk)
		if(reset == 1'b1)
			rd_event_data <= 5'b0;
		else if(dav_htr_buf_que == 1'b1 && rd_event_data == 5'b0 && cntr_que_afull == 1'b0 && (htr_rd_cntr[4] == 1'b1 || lrb_test == 1'b1))
			case (htr_buf_que_out[11:9])
				3'b000 : rd_event_data[0] <= event_data_rdy[0];
				3'b001 : rd_event_data[1] <= event_data_rdy[1];
				3'b010 : rd_event_data[2] <= event_data_rdy[2];
				3'b011 : rd_event_data[3] <= event_data_rdy[3];
				default : rd_event_data[4] <= event_data_rdy[4];
			endcase
		else if (rd_wc == 9'h1ff && event_buf_afull == 1'b0)
			rd_event_data <= 5'b0;
	always @(posedge clk)
		if(reset == 1'b1)
			htr_rd_cntr <= 5'b0;
		else if(htr_rd_cnt_str == 1'b1)
			htr_rd_cntr <= {1'b1, ~htr_rd_cnt};
		else if(re_htr_buf_que == 1'b1)
			htr_rd_cntr <= htr_rd_cntr + 1;
// check test data back from LRBs
reg [31:0] lfsr2 = 32'b0;
reg [31:0] saved_lfsr2 = 32'b0;
reg check_data = 1'b0;
reg save_lfsr = 1'b0;
reg check_lfsr = 1'b0;
reg [31:0] lfsr2_cntr = 32'b0;
reg [6:0]lrb_nump = 7'b0;
wire [6:0]lrb_num;
reg check_crc = 1'b0;
reg end_of_event = 1'b0;
reg rd_evt_data_dl = 1'b0;
	always @(posedge clk) begin
		rd_evt_data_dl <= rd_evt_data;
		check_data <= rd_evt_data_dl;
		event_data_val <= rd_evt_data_dl && ~lrb_test;
		end
	always @(posedge clk)
		if(reset == 1'b1 || event_buf_afull == 1'b1)
			re_event_data <= 5'b0;
		else
			re_event_data <= rd_event_data;
	always @(posedge clk)
		if(rd_evt_data == 1'b1 && rd_wc == 9'h0 && reset == 1'b0)
			end_of_event <= 1'b1;
		else
			end_of_event <= 1'b0;
	always @(posedge clk)
		check_crc <= end_of_event && ~reset;
	always @(posedge clk)
		eoe <= end_of_event;
	always @(posedge clk)
		save_lfsr <= check_crc && lrb_num[2] && lrb_test;
	always @(posedge clk)
		if(lrb_test == 1'b0)
			saved_lfsr2 <= 32'h0;
		else if(save_lfsr == 1'b1)
			saved_lfsr2 <= lfsr2;
	always @(posedge clk)
		if(lrb_test == 1'b0 || (check_crc == 1'b1 && lrb_num[2] == 1'b0))
			lfsr2 <= saved_lfsr2;
		else if(check_data == 1'b1)
			lfsr2 <= {lfsr2[30:0],~(lfsr2[31]^lfsr2[21]^lfsr2[1]^lfsr2[0])};
	always @(posedge clk)
		if(lrb_test == 1'b0)
			lfsr2_cntr <= 32'h0;
		else if(check_data == 1'b1) begin
			lfsr2_cntr[8:0] <= lfsr2_cntr[8:0] + 1;
			if(lrb_num[2] == 1'b1 && lfsr2_cntr[8:0] == 9'h1ff)
				lfsr2_cntr[31:9] <= lfsr2_cntr[31:9] + 1;
			end
	always @(posedge clk)
		if(re_htr_buf_que == 1'b1)
			lrb_nump <= htr_buf_que_out[15:9];
generate
	genvar i;
	for(i=0;i<7;i=i+1)
		begin : g_lrb_num
			delayN #(.N(2))i_lrb_num (.c(clk), .d(lrb_nump[i]), .ce(1'b1), .q(lrb_num[i]));
		end
endgenerate
reg h_equal = 1'b0;
reg l_equal = 1'b0;
	always @(posedge clk)
		check_lfsr <= check_data;
	always @(posedge clk)
//		if(lrb_event_data[31:16] == lfsr2_cntr[31:16])
		if(lrb_event_data[31:16] == lfsr2[31:16])
			h_equal <= 1'b1;
		else
			h_equal <= 1'b0;
	always @(posedge clk)
//		if(lrb_event_data[15:0] == lfsr2_cntr[15:0])
		if(lrb_event_data[15:0] == lfsr2[15:0])
			l_equal <= 1'b1;
		else
			l_equal <= 1'b0;
	always @(posedge clk)
		if(reset == 1'b1)
			lrb_err <= 4'b0;
		else if(check_lfsr == 1'b1 && (h_equal == 1'b0 || l_equal == 1'b0))
			case (lrb_num[2:0])
				3'b000 : lrb_err[0] <= 1'b1;
				3'b001 : lrb_err[1] <= 1'b1;
				3'b010 : lrb_err[2] <= 1'b1;
				3'b011 : lrb_err[3] <= 1'b1;
				default : lrb_err[4] <= 1'b1;
			endcase
reg [32:0] lrb_data_dl = 33'h0;
reg [31:0] lfsr2_dl = 32'h0;
reg [31:0] err_lfsr2 = 32'h0;
reg [31:0] err_data = 32'h0;
reg [31:0] err_loc = 32'h0;
reg [31:0] reg_data = 32'h0;
reg [8:0] info_buf_wa = 9'h0;
reg we_ev_info = 1'b0;
reg we_wpp = 1'b0;
reg we_wp = 1'b0;
wire [8:0] wp;
wire [8:0] spo_wp;
reg [11:0] lrb_wa = 12'h0;
reg [8:0] wp_plus_one;
reg [3:0] lrb_offset = 4'h0;
wire [8:0] d_dpo_wp;
wire [31:0] ev_info_dl;
reg rst_cycle = 1'b0;
reg last_info = 1'b0;
assign debug = reg_data;
	always @(posedge clk)
		d_info_fifo <= lrb0_event_info | lrb1_event_info | lrb2_event_info | lrb3_event_info | lrb4_event_info;
generate
	for(i=0;i<32;i=i+1)
		begin : g_ev_info_dl
			delayN #(.N(2))i_ev_info_dl (.c(clk), .d(lrb_event_info[i]), .ce(1'b1), .q(ev_info_dl[i]));
		end
endgenerate
ram16XNd #(.N(9)) i_wp_a (
    .clk(clk), 
    .we(we_wp), 
    .d(wp_plus_one), 
    .a(lrb_wa[3:0]), 
    .dpra(rp_addr), 
    .spo(spo_wp), 
    .dpo(d_dpo_wp)
    );
ram16XNd #(.N(9)) i_wp_b (
    .clk(clk), 
    .we(we_wp), 
    .d(wp_plus_one), 
    .a(lrb_wa[3:0]), 
    .dpra(wp_addr), 
    .spo(), 
    .dpo(wp)
    );
	always @(posedge clk)
		if(rst_cycle == 1'b1)
			htr_buf_ovf <= 0;
		else if(we_wp == 1 && rp[8] != spo_wp[8] && rp[7:0] == spo_wp[7:0])
			htr_buf_ovf[lrb_wa[3:0]] <= 1'b1;
	always @(posedge clk)
		if(strobe == 1'b1)
			dpo_wp <= d_dpo_wp;
	always @(posedge clk)
		lrb_wa <= {wp[7:0],wp_addr[3:0]};
	always @(posedge clk) begin
		lrb_offset[3] <= event_info_val[4] | event_info_val[3];
		lrb_offset[2] <= event_info_val[4] | event_info_val[2];
		lrb_offset[1] <= event_info_val[2] | event_info_val[1];
		lrb_offset[0] <= event_info_val[3] | event_info_val[1];
		end
	always @(posedge clk)
		if(rst_cycle == 1'b1)
			wp_plus_one <= 9'h0;
		else
			wp_plus_one <= wp + 1;
	always @(posedge clk)
		last_info <= lrb_event_info[32];
	always @(posedge clk)
		we_wpp <= we_ev_info || rst_cycle;
	always @(posedge clk)
		we_wp <= rst_cycle || (we_wpp && last_info);
	always @(posedge clk)
		if(rst_cycle == 1'b1)
			wp_addr <= wp_addr + 1;
		else
			wp_addr <= lrb_offset + {2'b0,lrb_event_info[25:24]};
	always @(posedge clk)
		if(reset == 1'b1 && strobe == 1'b1)
			info_buf_wa <= 9'b0;
		else if(we_ev_info == 1'b1)
			info_buf_wa <= info_buf_wa + 1;
reg rd_info_busy = 0;
	always @(posedge clk)
		if(re_event_info != 5'b0)
			rd_info_busy <= 1'b1;
		else
			rd_info_busy <= 1'b0;
	always @(posedge clk)
		if(re_event_info == 5'b0 && event_info_val == 5'b0 && rd_info_busy == 1'b0)begin
			if(event_info_rdy[0] == 1'b1)
				re_event_info <= 5'h1;
			else if(event_info_rdy[1] == 1'b1)
				re_event_info <= 5'h2;
			else if(event_info_rdy[2] == 1'b1)
				re_event_info <= 5'h4;
			else if(event_info_rdy[3] == 1'b1)
				re_event_info <= 5'h8;
			else if(event_info_rdy[4] == 1'b1)
				re_event_info <= 5'h10;
			else
				re_event_info <= 5'h0;
		end else
			re_event_info <= 5'h0;
reg we_info_fifo = 0;
wire dav_info_fifo;
wire [3:0] rp_info_fifo;
wire [32:0] lrb_event_info;
	always @(posedge clk)
		if(reset == 1'b1 || event_info_val == 5'b0)
			we_info_fifo <= 1'b0;
		else
			we_info_fifo <= 1'b1;
	always @(posedge clk)
		if(reset == 1'b1)
			we_ev_info <= 0;
		else if(dav_info_fifo == 1 && ((lrb_event_info[32] == 0 && rp_info_fifo !=  4'hf) || we_ev_info == 0))
			we_ev_info <= 1;
		else
			we_ev_info <= 0;
srl_fifo #(.N(33))i_info_fifo (
    .rst(reset), 
    .din(d_info_fifo), 
		.w_strobe(1'b1),
    .we(we_info_fifo), 
    .clk(clk), 
		.r_strobe(1'b1),
    .re(we_ev_info), 
    .dout(lrb_event_info),
		.dav(dav_info_fifo),
    .rp(rp_info_fifo)
    );
	always @(posedge clk)
		lrb_data_dl <= lrb_event_data;
	always @(posedge clk)
		lfsr2_dl <= lfsr2;
	always @(posedge clk)
		if(lrb_err == 5'b0) begin
			err_loc <= {lrb_num[2:0],re_event_data[4:0],lfsr2_cntr[23:0]};
			err_data <= lrb_data_dl[31:0];
			err_lfsr2 <= lfsr2_dl;
			end
wire [23:0] evn_in;
wire [1:0] d_info_wc;
wire [1:0] info_wc;
wire [18:0] htr_status_in;
reg rst_cycle_dl = 1'b0;
reg wr_evn = 1'b0;
reg wr_htrstatus = 1'b0;
reg htr_err = 1'b0;
reg chk_htrstatus = 1'b0;
reg wr_bcn = 1'b0;
assign d_info_wc[1] = ~last_info & ~rst_cycle_dl & (info_wc[1]^info_wc[0]);
assign d_info_wc[0] = ~last_info & ~rst_cycle_dl & ~info_wc[0];
	always @(posedge clk)
		rst_cycle_dl <= rst_cycle;
ram16XNs #(.N(2)) i_info_wc (
    .clk(clk), 
    .we(we_wpp), 
    .d(d_info_wc), 
    .a(wp_addr), 
    .o(info_wc)
    );
	always @(posedge clk)
		if(last_info == 1'b0 && info_wc == 2'h0 && we_wpp == 1'b1)
			wr_evn <= 1'b1;
		else
			wr_evn <= 1'b0;
	always @(posedge clk)
		if(last_info == 1'b0 && info_wc == 2'h1 && we_wpp == 1'b1)
			wr_htrstatus <= 1'b1;
		else
			wr_htrstatus <= 1'b0;
	always @(posedge clk)
		if(last_info == 1'b0 && info_wc == 2'h2 && we_wpp == 1'b1)
			wr_bcn <= 1'b1;
		else
			wr_bcn <= 1'b0;
	always @(posedge clk)
		if(lrb_event_info[32] == 1'b0 && lrb_event_info[15] == 1'b1)
			htr_err <= 1'b1;
		else
			htr_err <= 1'b0;
	always @(posedge clk)
		if(htr_err == 1'b1 && info_wc == 2'h1 && we_wpp == 1'b1)
			chk_htrstatus <= 1'b1;
		else
			chk_htrstatus <= 1'b0;
assign htr_status_in = {lrb_wa[3:0],ev_info_dl[14:0]};
HTRstatus i_HTRstatus (
    .reset(reset), 
    .rst_cycle(rst_cycle), 
    .clk(clk), 
    .strobe(strobe), 
    .addr(addr), 
    .we_byte(we_byte), 
    .w_data(w_data), 
    .wr_htr_status(chk_htrstatus), 
    .htr_status_in(htr_status_in), 
    .state_LUT(htr_state_LUT), 
    .HTR_ow(HTR_ow), 
    .HTR_bz(HTR_bz), 
    .HTR_state(HTR_state)
    );
assign evn_in = {ev_info_dl[31:26],ev_info_dl[9:8],ev_info_dl[23:16],ev_info_dl[7:0]};
generate
	for(i=0;i<6;i=i+1) begin : g_evn
RAMB16_S4_S4 #(.SIM_COLLISION_CHECK("NONE"))
    i_evn (
      .DOA(),     // Port A 4-bit data output
      .DOB(lrb_evn[4*i+3:4*i]),     // Port B 4-bit data output
      .ADDRA(lrb_wa), // Port A 12-bit address input
      .ADDRB(evn_ra), // Port B 12-bit address input
      .CLKA(clk),   // Port A clock input
      .CLKB(clk),   // Port B clock input
      .DIA(evn_in[4*i+3:4*i]),     // Port A 4-bit data input
      .DIB(4'b0),     // Port B 4-bit data input
      .ENA(1'b1),     // Port A RAM enable input
      .ENB(strobe),     // Port B RAM enable input
      .SSRA(1'b0),   // Port A Synchronous set/reset input
      .SSRB(1'b0),   // Port B Synchronous set/reset input
      .WEA(wr_evn),     // Port A RAM write enable input
      .WEB(1'b0)      // Port B RAM write enable input
   );
	 end
endgenerate
generate
	for(i=0;i<3;i=i+1) begin : g_bcn
RAMB16_S4_S4 #(.SIM_COLLISION_CHECK("NONE"))
    i_bcn (
      .DOA(),     // Port A 4-bit data output
      .DOB(lrb_evn[4*i+27:4*i+24]),     // Port B 4-bit data output
      .ADDRA(lrb_wa), // Port A 12-bit address input
      .ADDRB(evn_ra), // Port B 12-bit address input
      .CLKA(clk),   // Port A clock input
      .CLKB(clk),   // Port B clock input
      .DIA(ev_info_dl[4*i+3:4*i]),     // Port A 4-bit data input
      .DIB(4'b0),     // Port B 4-bit data input
      .ENA(1'b1),     // Port A RAM enable input
      .ENB(strobe),     // Port B RAM enable input
      .SSRA(1'b0),   // Port A Synchronous set/reset input
      .SSRB(1'b0),   // Port B Synchronous set/reset input
      .WEA(wr_bcn),     // Port A RAM write enable input
      .WEB(1'b0)      // Port B RAM write enable input
   );
	 end
endgenerate
wire [7:0] htr_oc;
assign lrb_evn[40:36] = htr_oc[7:3];
generate
	for(i=0;i<2;i=i+1) begin : g_oc
RAMB16_S4_S4 #(.SIM_COLLISION_CHECK("NONE"))
    i_oc (
      .DOA(),     // Port A 4-bit data output
      .DOB(htr_oc[4*i+3:4*i]),     // Port B 4-bit data output
      .ADDRA(lrb_wa), // Port A 12-bit address input
      .ADDRB(evn_ra), // Port B 12-bit address input
      .CLKA(clk),   // Port A clock input
      .CLKB(clk),   // Port B clock input
      .DIA(ev_info_dl[4*i+27:4*i+24]),     // Port A 4-bit data input
      .DIB(4'b0),     // Port B 4-bit data input
      .ENA(1'b1),     // Port A RAM enable input
      .ENB(strobe),     // Port B RAM enable input
      .SSRA(1'b0),   // Port A Synchronous set/reset input
      .SSRB(1'b0),   // Port B Synchronous set/reset input
      .WEA(wr_htrstatus),     // Port A RAM write enable input
      .WEB(1'b0)      // Port B RAM write enable input
   );
	 end
endgenerate
generate
	for(i=0;i<2;i=i+1) begin : g_htrstatus
RAMB16_S4_S4 #(.SIM_COLLISION_CHECK("NONE"))
    i_htrstatus (
      .DOA(),     // Port A 4-bit data output
      .DOB(summary[4*i+27:4*i+24]),     // Port B 4-bit data output
      .ADDRA(lrb_wa), // Port A 12-bit address input
      .ADDRB(smry_ra), // Port B 12-bit address input
      .CLKA(clk),   // Port A clock input
      .CLKB(clk),   // Port B clock input
      .DIA(ev_info_dl[4*i+3:4*i]),     // Port A 4-bit data input
      .DIB(4'b0),     // Port B 4-bit data input
      .ENA(1'b1),     // Port A RAM enable input
      .ENB(strobe),     // Port B RAM enable input
      .SSRA(1'b0),   // Port A Synchronous set/reset input
      .SSRB(1'b0),   // Port B Synchronous set/reset input
      .WEA(wr_htrstatus),     // Port A RAM write enable input
      .WEB(1'b0)      // Port B RAM write enable input
   );
	 end
endgenerate
wire [19:0] trailer_in;
wire [19:0] trailer;
wire cal_trig;
assign trailer_in = {1'b0,cal_trig,ev_info_dl[23:16],ev_info_dl[9:0]};
   RAM16X1S i_cal_trig (
      .O(cal_trig),       // RAM output
      .A0(lrb_wa[0]),     // RAM address[0] input
      .A1(lrb_wa[1]),     // RAM address[1] input
      .A2(lrb_wa[2]),     // RAM address[2] input
      .A3(lrb_wa[3]),     // RAM address[3] input
      .D(ev_info_dl[14]),       // RAM data input
      .WCLK(clk), // Write clock input
      .WE(wr_htrstatus)      // Write enable input
   );
generate
	for(i=0;i<5;i=i+1) begin : g_trailer
RAMB16_S4_S4 #(.SIM_COLLISION_CHECK("NONE"))
    i_trailer (
      .DOA(),     // Port A 4-bit data output
      .DOB(trailer[4*i+3:4*i]),     // Port B 4-bit data output
      .ADDRA(lrb_wa), // Port A 12-bit address input
      .ADDRB(smry_ra), // Port B 12-bit address input
      .CLKA(clk),   // Port A clock input
      .CLKB(clk),   // Port B clock input
      .DIA(trailer_in[4*i+3:4*i]),     // Port A 4-bit data input
      .DIB(4'b0),     // Port B 4-bit data input
      .ENA(1'b1),     // Port A RAM enable input
      .ENB(strobe),     // Port B RAM enable input
      .SSRA(1'b0),   // Port A Synchronous set/reset input
      .SSRB(1'b0),   // Port B Synchronous set/reset input
      .WEA(we_wp),     // Port A RAM write enable input
      .WEB(1'b0)      // Port B RAM write enable input
   );
	 end
endgenerate
assign summary[23:16] = trailer[17:10]; // lrb_err
assign summary[15] = trailer[18]; // calibration trigger
assign summary[14:12] = 3'b100; // EPV
assign summary[11] = trailer[12]; // truncate error
assign summary[10] = trailer[14]; // LRB CRC error
assign summary[9:0] = trailer[9:0]; // event length
wire set_init_crc;
reg init_crc = 1'b0;
reg crc_err = 1'b0;
reg [15:0] crc_data_h = 16'b0;
wire [31:0] crc_data;
wire [15:0] crc;
	assign crc_data = {crc_data_h[15:0],lrb_event_data[15:0]};
delayN #(.N(2))i_init_crc (.c(clk), .d(re_htr_buf_que), .ce(1'b1), .q(set_init_crc));
	always @(posedge clk)
		if(set_init_crc == 1)
			init_crc <= 1;
		else if(check_data == 1)
			init_crc <= 0;
	always @(posedge clk)
		if(check_data == 1)
			crc_data_h <= lrb_event_data[31:16];
crc16D32 i_crc (
    .clk(clk), 
    .init_crc(init_crc), 
    .we_crc(check_data), 
    .d(crc_data), 
    .crc(crc)
    );
	always @(posedge clk)
		if(check_crc == 1'b1 && crc != crc_data[31:16] && lrb_test == 1'b0)
			crc_err <= 1'b1;
		else
			crc_err <= 1'b0;
// counters
reg [2:0]header_cntr = 0;
reg check_crc_dl = 0;
reg htr_status_bad = 0;
reg htr_status_word = 0;
reg got_status_word = 0;
reg we_cntr_que = 0;
reg re_cntr_que = 0;
wire dav_cntr_que;
reg [30:0] cntr_que_din = 0;
wire [30:0] cntr_que_dout;
wire [3:0] rp_cntr_que;
	always @(posedge clk)
		if(lrb_test == 1)
			header_cntr <= 3'h7;
//		else if(reset == 1 || check_crc_dl == 1)
		else if(init_crc == 1)
			header_cntr <= 0;
		else if(header_cntr[2] == 0 && check_lfsr == 1)
			header_cntr <= header_cntr + 1;
//	always @(posedge clk)
//		if(lrb_test == 1)
//			got_status_word <= 1;
//		else if(reset == 1 || check_crc_dl == 1)
//			got_status_word <= 0;
//		else if(check_lfsr == 1)
//			got_status_word <= 1;
//	always @(posedge clk)
//		if(got_status_word == 1)
//			htr_status_word <= 0;
//		else if(check_lfsr == 1)
//			htr_status_word <= 1;
	always @(posedge clk)
		if(header_cntr[1:0] == 2'b01)
			if(lrb_event_data[15] == 0 || lrb_event_data[14] == 1 || lrb_event_data[11:0] != 0)
				htr_status_bad <= 1;
			else
				htr_status_bad <= 0;
	always @(posedge clk)
		if(init_crc == 1'b1)
			cntr_que_din[25:16] <= 10'b0;
		else if(check_lfsr == 1 && (lrb_test == 0 || h_equal == 1'b0 || l_equal == 1'b0))
			cntr_que_din[25:16] <= cntr_que_din[25:16] + 1;
	always @(posedge clk) begin
		cntr_que_din[26] <= check_crc_dl;
		cntr_que_din[30:27] <= lrb_num[6:3];
		check_crc_dl <= check_crc && ~reset;
		if(check_crc_dl == 1'b1) begin
			cntr_que_din[15:10] <= 6'h1;
			cntr_que_din[9] <= crc_err ^ lrb_data_dl[20]; // crc error different from that of LRB
			cntr_que_din[8] <= crc_err;
			cntr_que_din[7:0] <= lrb_data_dl[23:16];
		end else if(header_cntr[1:0] == 2'b01 && lrb_data_dl[15] == 1)
			cntr_que_din[14:0] <= {lrb_data_dl[14],1'b0,lrb_data_dl[12:0]};
		else if(header_cntr[1:0] == 2'b01 && lrb_data_dl[15] == 0) begin
			cntr_que_din[29:26] <= 5'h0;
			cntr_que_din[14:0] <= 15'h200;
		end else if(header_cntr == 3'h3)
		cntr_que_din[15] <= lrb_data_dl[14];
		if((check_crc_dl == 1 || (header_cntr[1:0] == 2'b11 && (htr_status_bad == 1 || lrb_data_dl[14] == 1))) && reset == 0)
			we_cntr_que <= 1;
		else
			we_cntr_que <= 0;
	end
// if cntr_que_dout[21] == 0, cntr_que_dout[10:0] are HTR status counts
// if cntr_que_dout[21] == 1, cntr_que_dout[20:11] are LRB word counts, cntr_que_dout[9:0] are LRB error counts
srl_fifo #(.N(31))i_cntr_que (
    .rst(reset), 
    .din(cntr_que_din), 
		.w_strobe(1'b1),
    .we(we_cntr_que), 
    .clk(clk), 
		.r_strobe(1'b1),
    .re(re_cntr_que), 
		.dav(dav_cntr_que),
    .dout(cntr_que_dout),
		.rp(rp_cntr_que)
    );
	always@(posedge clk)
		cntr_que_afull <= rp_cntr_que[3] && ~rp_cntr_que[2];
reg rst_counter = 0;
reg we_counter = 0;
reg cntr_busy = 0;
reg carry_out = 0;
reg carry_in = 0;
wire [31:0] counter_do;
reg [2:0] inc_counter = 0;
reg [15:0] sel = 0;
reg [31:0] counter_di = 0;
reg [25:0] cntr_que_out_l = 0;
reg [8:0] counter_wa = 0;
	always@(posedge clk)
		if(cntr_busy == 0 && rst_counter == 0 && dav_cntr_que == 1) begin
			re_cntr_que <= 1;
			cntr_busy <= 1;
		end else begin	
			re_cntr_que <= 0;
			if((cntr_que_out_l[15:0] == 0 && counter_wa[4] == 1) || (sel[10] == 0 && counter_wa[4] == 0))	
				cntr_busy <= 0;
		end
	always@(posedge clk)
		if(reset == 1)
			rst_cycle <= 1;
		else if(counter_wa[0] == 1)
			rst_cycle <= 0;
	always@(posedge clk)
		if(reset == 1)
			rst_counter <= 1;
		else if(counter_wa == 9'h1bf)
			rst_counter <= 0;
	always@(posedge clk)
		if(reset == 1) begin
			counter_wa[8:5] <= 0;
			counter_wa[4] <= 0;
		end else if(rst_counter == 1) begin
		  if(counter_wa[8:5] == 4'he) begin
				counter_wa[8:5] <= 0;
				if(counter_wa[3:0] == 4'hd)
					counter_wa[4] <= 1;
			end else
				counter_wa[8:5] <= counter_wa[8:5] + 1;
		end else if(cntr_busy == 0) begin
			counter_wa[4] <= ~cntr_que_dout[26];
			counter_wa[8:5] <= cntr_que_dout[30:27];
		end
	always@(posedge clk)
		if(rst_counter == 1)
			inc_counter <= 0;
		else begin
			inc_counter[0] <= re_cntr_que || inc_counter[2];
			if(sel == 0)
				inc_counter[2:1] <= 0;
			else
				inc_counter[2:1] <= inc_counter[1:0];
		end
	always@(posedge clk)
		if(cntr_busy == 0)
			carry_in <= 1;
		else if(we_counter == 1)
			carry_in <= carry_out || ~sel[10] || counter_wa[0];
	always@(posedge clk)
		if(rst_counter == 1)
			we_counter <= 1;
		else
			we_counter <= inc_counter[2];
	always@(posedge clk)
		if(rst_counter == 1) begin
			counter_di <= 0;
			carry_out <= 0;
		end else if(counter_wa[4:0] == 5'ha)
			{carry_out,counter_di} <= counter_do + {22'h0,cntr_que_out_l[25:16]};
		else
			{carry_out,counter_di} <= counter_do + carry_in;
	always@(posedge clk)
		if(cntr_busy == 0) begin
			cntr_que_out_l <= cntr_que_dout[25:0];
		end else if(inc_counter[1] == 1)
			cntr_que_out_l[15:0] <= cntr_que_out_l[15:0] & ~sel[15:0];
	always@(posedge clk)
		if(cntr_busy == 0)
			sel <= 0;
		else if(cntr_que_out_l[0] == 1)
			sel <= 16'h1;
		else if(cntr_que_out_l[1] == 1)
			sel <= 16'h2;
		else if(cntr_que_out_l[2] == 1)
			sel <= 16'h4;
		else if(cntr_que_out_l[3] == 1)
			sel <= 16'h8;
		else if(cntr_que_out_l[4] == 1)
			sel <= 16'h10;
		else if(cntr_que_out_l[5] == 1)
			sel <= 16'h20;
		else if(cntr_que_out_l[6] == 1)
			sel <= 16'h40;
		else if(cntr_que_out_l[7] == 1)
			sel <= 16'h80;
		else if(cntr_que_out_l[8] == 1)
			sel <= 16'h100;
		else if(cntr_que_out_l[9] == 1)
			sel <= 16'h200;
		else if(cntr_que_out_l[10] == 1)
			sel <= 16'h400;
		else if(cntr_que_out_l[11] == 1)
			sel <= 16'h800;
		else if(cntr_que_out_l[12] == 1)
			sel <= 16'h1000;
		else if(cntr_que_out_l[13] == 1)
			sel <= 16'h2000;
		else if(cntr_que_out_l[14] == 1)
			sel <= 16'h4000;
		else if(cntr_que_out_l[15] == 1)
			sel <= 16'h8000;
		else if(sel[10] == 1 && counter_wa[4] == 0 ) begin
			if(counter_wa[3:2] == 3 && (counter_wa[0] == 1 || carry_out == 0) && we_counter == 1)
				sel <= 0;
		end else
			sel <= 0;
	always@(posedge clk)
		if(rst_counter == 1) begin
			if(counter_wa[8:5] == 4'he) begin
				if(counter_wa[3:0] == 4'hd)
					counter_wa[3:0] <= 0;
				else
					counter_wa[3:0] <= counter_wa[3:0] + 1;
			end
		end else if(sel[10] == 1 && counter_wa[4:3] == 1 && counter_wa[2:1] != 0) begin
			if(inc_counter[0] == 1)
				counter_wa[3:0] <= counter_wa[3:0] + 1;
		end else begin
			counter_wa[3] <= sel[15] | sel[14] | sel[13] | sel[12] | sel[11] | sel[10] | sel[9] | sel[8];
			counter_wa[2] <= sel[15] | sel[14] | sel[13] | sel[12] | sel[7] | sel[6] | sel[5] | sel[4];
			counter_wa[1] <= sel[15] | sel[14] | sel[11] | sel[10] | sel[7] | sel[6] | sel[3] | sel[2];
			counter_wa[0] <= sel[15] | sel[13] | sel[11] | sel[9] | sel[7] | sel[5] | sel[3] | sel[1];
		end
RAMB16_S36_S36 #(.SIM_COLLISION_CHECK("NONE"))
			i_counter(
      .DOA(counter_do),      // Port A 32-bit Data Output
      .DOB(counters),      // Port B 32-bit Data Output
      .DOPA(),    // Port A 4-bit Parity Output
      .DOPB(),    // Port B 4-bit Parity Output
      .ADDRA(counter_wa),  // Port A 9-bit Address Input
      .ADDRB(addr[8:0]),  // Port B 9-bit Address Input
      .CLKA(clk),    // Port A Clock
      .CLKB(clk),    // Port B Clock
      .DIA(counter_di),      // Port A 32-bit Data Input
      .DIB(32'b0),      // Port B 32-bit Data Input
      .DIPA(4'b0),    // Port A 4-bit parity Input
      .DIPB(4'b0),    // Port-B 4-bit parity Input
      .ENA(1'b1),      // Port A RAM Enable Input
      .ENB(strobe),      // Port B RAM Enable Input
      .SSRA(1'b0),    // Port A Synchronous Set/Reset Input
      .SSRB(rd_counters_n),    // Port B Synchronous Set/Reset Input
      .WEA(we_counter),      // Port A Write Enable Input
      .WEB(1'b0)       // Port B Write Enable Input
   );
assign rd_counters_n = (addr[14:9] == counter_addr[14:9]) ? 0 : 1;
reg [15:0] rst_htr_req_cntr = 16'hffff;
wire we_htr_req_cntr;
wire [31:0] d_htr_req_cntrp;
wire [31:0] htr_req_cntrp;
wire [31:0] htr_req_cntr;
	always @(posedge clk)
		if(strobe == 1'b1)begin
			if(reset == 1)
				rst_htr_req_cntr <= 16'hffff;
			else if(htr_buf_req == 1)
				rst_htr_req_cntr[htr_buf_addr[11:8]] <= 1'b0;
		end
ram16XNd #(.N(32)) i_htr_req_cntr (
    .clk(clk), 
    .we(we_htr_req_cntr), 
    .d(d_htr_req_cntrp), 
    .a(htr_buf_addr[11:8]), 
    .dpra(addr[3:0]), 
    .spo(htr_req_cntrp), 
    .dpo(htr_req_cntr)
    );
assign we_htr_req_cntr = htr_buf_req && strobe;
assign d_htr_req_cntrp = rst_htr_req_cntr[htr_buf_addr[11:8]] ? 32'h1 : htr_req_cntrp + 1;
	always @(posedge clk)
		if(strobe == 1'b1)begin
			if(addr[14:6] != debug_addr[14:6])
				reg_data <= 32'h0;
			else
				case (addr[4:0])
					5'h0 : reg_data <= lfsr2_cntr[31:0];
					5'h1 : reg_data <= {5'h10,lrb_err[4:0], event_data_rdy[4:0], save_lfsr, check_data, rd_evt_data, rd_event_data[4:0], rd_wc[8:0]};
					5'h2 : reg_data <= err_loc[31:0];
					5'h3 : reg_data <= {10'h3c0,ec_lfsr,lrb_ack_l[4:0],lfsr_cntr[15:0]};
					5'h4 : reg_data <= {1'b1, lrb_nump[6:0], dav_htr_buf_que, lrb_num[6:0], htr_buf_que_out[15:0]};
					5'h5 : reg_data <= err_data[31:0];
//					3'h6 : reg_data <= {3'h4, re_event_info[4:0], 3'h0, event_info_rdy[4:0],7'b0, info_buf_wa[8:0]};
					5'h6 : reg_data <= err_lfsr2[31:0];
					5'h7 : reg_data <= lfsr_cntr[47:16];
					5'h8 : reg_data <= {ofw_htr_buf_que, 15'h0, max_htr_buf[15:0]};
					default : reg_data <= htr_req_cntr;
				endcase
		end
ROM16X1 #(.INIT(16'h2492)) i_lrb_ch0 (
			.O(lrb_ch[0]),   // ROM output
			.A0(htr_buf_addr[8]), // ROM address[0]
			.A1(htr_buf_addr[9]), // ROM address[1]
			.A2(htr_buf_addr[10]), // ROM address[2]
			.A3(htr_buf_addr[11])  // ROM address[3]
	 );
ROM16X1 #(.INIT(16'h4924)) i_lrb_ch1 (
			.O(lrb_ch[1]),   // ROM output
			.A0(htr_buf_addr[8]), // ROM address[0]
			.A1(htr_buf_addr[9]), // ROM address[1]
			.A2(htr_buf_addr[10]), // ROM address[2]
			.A3(htr_buf_addr[11])  // ROM address[3]
	 );
ROM16X1 #(.INIT(16'h0e38)) i_lrb_ch2 (
			.O(lrb_ch[2]),   // ROM output
			.A0(htr_buf_addr[8]), // ROM address[0]
			.A1(htr_buf_addr[9]), // ROM address[1]
			.A2(htr_buf_addr[10]), // ROM address[2]
			.A3(htr_buf_addr[11])  // ROM address[3]
	 );
ROM16X1 #(.INIT(16'h0fc0)) i_lrb_ch3 (
			.O(lrb_ch[3]),   // ROM output
			.A0(htr_buf_addr[8]), // ROM address[0]
			.A1(htr_buf_addr[9]), // ROM address[1]
			.A2(htr_buf_addr[10]), // ROM address[2]
			.A3(htr_buf_addr[11])  // ROM address[3]
	 );
ROM16X1 #(.INIT(16'h7000)) i_lrb_ch4 (
			.O(lrb_ch[4]),   // ROM output
			.A0(htr_buf_addr[8]), // ROM address[0]
			.A1(htr_buf_addr[9]), // ROM address[1]
			.A2(htr_buf_addr[10]), // ROM address[2]
			.A3(htr_buf_addr[11])  // ROM address[3]
	 );
endmodule
