----------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
library UNISIM;
use UNISIM.VComponents.all;

entity ddr_io is
    port (
        clk: in STD_LOGIC;
        clkn: in STD_LOGIC;
        pad: inout std_logic;
        t: in STD_LOGIC;
        d0: in STD_LOGIC;
        d1: in STD_LOGIC;
        iclk: in STD_LOGIC;
        iclkn: in STD_LOGIC;
        q0: out std_logic; -- rising edge       
        q1: out std_logic  -- falling edge    
    );
end ddr_io;

architecture ddr_io_arch of ddr_io is
signal din, oq, tq: std_logic :='0';
attribute IOB : string;
attribute IOB of tq_reg: label is "TRUE";
begin
ib: ibuf port map(i => pad, o => din);
iq_reg : IDDR2
   port map (
      Q0 => Q0, -- 1-bit output captured with C0 clock
      Q1 => Q1, -- 1-bit output captured with C1 clock
      C0 => iclk, -- 1-bit clock input
      C1 => iclkn, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D => din,   -- 1-bit data input 
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
oq_reg:  ODDR2
    port map(
          d0 => d0,
          d1 => d1,
          c0 => clk,
          c1 => clkn,
          ce => '1',
          r  => '0',
          s  => '0',
          q  => oq);
tq_reg:  fd
    port map(
          d => t,
          c => clk,
          q  => tq);
ob: obuft port map( i => oq, o => pad, t => tq);
end ddr_io_arch;
