library IEEE;
use IEEE.std_logic_1164.all;
library UNISIM;
use UNISIM.VComponents.all;
entity ram16XNs is
    generic ( N : positive := 16);
    port (
        clk: in STD_LOGIC;
        we: in STD_LOGIC;
        d: in STD_LOGIC_VECTOR (N-1 downto 0);
        a: in STD_LOGIC_VECTOR (3 downto 0);
        o: out STD_LOGIC_VECTOR (N-1 downto 0)
    );
end ram16XNs;

architecture ram16XNs_arch of ram16XNs is
begin
g0: for i in d'range generate
ram: ram16x1s
    port map(
             we => we,
             wclk => clk,
             d => d(i),
             a0 => a(0),
             a1 => a(1),
             a2 => a(2),
             a3 => a(3),
             o => o(i));
end generate;
end ram16XNs_arch; 
