----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:36:07 04/22/2009 
-- Design Name: 
-- Module Name:    edc - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.STD_LOGIC_MISC.ALL;
use mylib.dcc_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity edc is
	PORT(
		clk : IN std_logic;
		n_strobe : IN std_logic;
		reset : IN std_logic;
		addr : IN std_logic_vector(15 downto 0);
		w_data : IN std_logic_vector(31 downto 0);
		we_byte : IN std_logic_vector(3 downto 0);
		test_ctrl : IN std_logic_vector(3 downto 0);
		lrb_test : IN std_logic;
		htr_buf_addr : IN std_logic_vector(11 downto 0);
		htr_buf_length : IN std_logic_vector(8 downto 0);
		htr_buf_req : IN std_logic;
		event_data_rdy : IN std_logic_vector(4 downto 0);
		lrb0_event_data : IN std_logic_vector(32 downto 0);
		lrb1_event_data : IN std_logic_vector(32 downto 0);
		lrb2_event_data : IN std_logic_vector(32 downto 0);
		lrb3_event_data : IN std_logic_vector(32 downto 0);
		lrb4_event_data : IN std_logic_vector(32 downto 0);
		event_info_val : IN std_logic_vector(4 downto 0);
		event_info_rdy : IN std_logic_vector(4 downto 0);
		lrb0_event_info : IN std_logic_vector(32 downto 0);
		lrb1_event_info : IN std_logic_vector(32 downto 0);
		lrb2_event_info : IN std_logic_vector(32 downto 0);
		lrb3_event_info : IN std_logic_vector(32 downto 0);
		lrb4_event_info : IN std_logic_vector(32 downto 0);
		event_buf_afull : IN std_logic;
		lrb_ack : IN std_logic_vector(4 downto 0);
		htr_rd_cnt : IN std_logic_vector(3 downto 0);
		rp_addr : IN std_logic_vector(3 downto 0);
		rp : IN std_logic_vector(8 downto 0);
		wp_addr : OUT std_logic_vector(3 downto 0);
		dpo_wp : OUT std_logic_vector(8 downto 0);
		htr_buf_ovf : OUT std_logic_vector(14 downto 0);
		htr_rd_cnt_str : IN std_logic;
		re_event_data : OUT std_logic_vector(4 downto 0);
		rd_next_event : OUT std_logic_vector(4 downto 0);
		re_event_info : OUT std_logic_vector(4 downto 0);
		event_data_req_str : OUT std_logic_vector(4 downto 0);
		event_data_req : OUT std_logic_vector(18 downto 0);
		event_data_val : OUT std_logic;
		event_data : OUT std_logic_vector(32 downto 0);
		lrb_test_str : OUT std_logic;
		lrb_test_data : OUT std_logic_vector(31 downto 0);
		debug : OUT std_logic_vector(31 downto 0);
		evn_ra : IN std_logic_vector(11 downto 0);
		smry_ra : IN std_logic_vector(11 downto 0);
		summary : OUT std_logic_vector(31 downto 0);
		lrb_evn : OUT std_logic_vector(40 downto 0);
		counters : OUT std_logic_vector(31 downto 0);
		debug_addr : IN std_logic_vector(14 downto 0);
		counter_addr : IN std_logic_vector(14 downto 0);
		htr_state_LUT : OUT std_logic_vector(31 downto 0);
		HTR_ow : OUT std_logic;
		HTR_bz : OUT std_logic;
		HTR_state : OUT std_logic_vector(1 downto 0)
		);
end edc;

architecture Behavioral of edc is
signal strobe : std_logic := '0';
signal eoe : std_logic := '0';
signal ec_lfsr : std_logic := '0';
signal lrb_err : std_logic_vector(4 downto 0) := (others => '0');
signal lfsr : std_logic_vector(31 downto 0) := (others => '0');
signal lfsr_cntr : std_logic_vector(47 downto 0) := (others => '0');
signal lrb_ack_l : std_logic_vector(4 downto 0) := (others => '0');
signal lrb_event_data : std_logic_vector(32 downto 0) := (others => '0');
signal lrb_event_info : std_logic_vector(32 downto 0) := (others => '0');
signal lrb_ch : std_logic_vector(4 downto 0) := (others => '0');
signal we_htr_buf_que : std_logic := '0';
signal re_htr_buf_que : std_logic := '0';
signal dav_htr_buf_que : std_logic := '0';
signal htr_buf_que_in : std_logic_vector(15 downto 0) := (others => '0');
signal htr_buf_que_out : std_logic_vector(15 downto 0) := (others => '0');
signal rd_event_data : std_logic_vector(4 downto 0) := (others => '0');
signal cntr_que_afull : std_logic := '0';
signal htr_rd_cntr : std_logic_vector(4 downto 0) := (others => '0');
signal rd_wc : std_logic_vector(8 downto 0) := (others => '0');
signal rd_evt_data : std_logic := '0';
signal rd_idle : std_logic := '0';
signal lfsr2 : std_logic_vector(31 downto 0) := (others => '0');
signal saved_lfsr2 : std_logic_vector(31 downto 0) := (others => '0');
signal lfsr2_cntr : std_logic_vector(31 downto 0) := (others => '0');
signal lrb_nump : std_logic_vector(6 downto 0) := (others => '0');
signal lrb_num : std_logic_vector(6 downto 0) := (others => '0');
signal check_data : std_logic := '0';
signal save_lfsr : std_logic := '0';
signal check_lfsr : std_logic := '0';
signal h_equal : std_logic := '0';
signal l_equal : std_logic := '0';
signal check_crc : std_logic := '0';
signal end_of_event : std_logic := '0';
signal rd_evt_data_dl : std_logic := '0';
signal lrb_data_dl : std_logic_vector(32 downto 0) := (others => '0');
signal lfsr2_dl : std_logic_vector(31 downto 0) := (others => '0');
signal err_lfsr2 : std_logic_vector(31 downto 0) := (others => '0');
signal err_data : std_logic_vector(31 downto 0) := (others => '0');
signal err_loc : std_logic_vector(31 downto 0) := (others => '0');
signal reg_data : std_logic_vector(31 downto 0) := (others => '0');
signal info_buf_wa : std_logic_vector(8 downto 0) := (others => '0');
signal wp : std_logic_vector(8 downto 0) := (others => '0');
signal spo_wp : std_logic_vector(8 downto 0) := (others => '0');
signal wp_plus_one : std_logic_vector(8 downto 0) := (others => '0');
signal lrb_wa : std_logic_vector(11 downto 0) := (others => '0');
signal wp_addr_i : std_logic_vector(3 downto 0) := (others => '0');
signal lrb_offset : std_logic_vector(3 downto 0) := (others => '0');
signal d_dpo_wp : std_logic_vector(8 downto 0) := (others => '0');
signal ev_info_dl : std_logic_vector(31 downto 0) := (others => '0');
signal we_ev_info : std_logic := '0';
signal rd_info_busy : std_logic := '0';
signal re_event_info_i : std_logic_vector(4 downto 0) := (others => '0');
signal re_event_data_i : std_logic_vector(4 downto 0) := (others => '0');
signal we_wpp : std_logic := '0';
signal we_wp : std_logic := '0';
signal rst_cycle : std_logic := '0';
signal last_info : std_logic := '0';
signal evn_in : std_logic_vector(23 downto 0) := (others => '0');
signal d_info_wc : std_logic_vector(1 downto 0) := (others => '0');
signal info_wc : std_logic_vector(1 downto 0) := (others => '0');
signal htr_status_in : std_logic_vector(18 downto 0) := (others => '0');
signal last_lrb_ch : std_logic_vector(1 downto 0) := (others => '0');
signal sel_wp_plus_one : std_logic := '0';
signal rst_cycle_dl : std_logic := '0';
signal wr_evn : std_logic := '0';
signal wr_htrstatus : std_logic := '0';
signal htr_err : std_logic := '0';
signal chk_htrstatus : std_logic := '0';
signal wr_bcn : std_logic := '0';
signal htr_oc : std_logic_vector(7 downto 0) := (others => '0');
signal trailer_in : std_logic_vector(19 downto 0) := (others => '0');
signal trailer : std_logic_vector(19 downto 0) := (others => '0');
signal cal_trig : std_logic := '0';
signal crc_data_h : std_logic_vector(15 downto 0) := (others => '0');
signal crc_data : std_logic_vector(31 downto 0) := (others => '0');
signal crc : std_logic_vector(15 downto 0) := (others => '0');
signal set_init_crc : std_logic := '0';
signal init_crc : std_logic := '0';
signal crc_err : std_logic := '0';
signal header_cntr : std_logic_vector(2 downto 0) := (others => '0');
signal check_crc_dl : std_logic := '0';
signal check_US : std_logic := '0';
signal ec_htr_status : std_logic := '0';
signal we_cntr_que : std_logic := '0';
signal re_cntr_que : std_logic := '0';
signal dav_cntr_que : std_logic := '0';
signal cntr_que_din : std_logic_vector(30 downto 0) := (others => '0');
signal cntr_que_dout : std_logic_vector(30 downto 0) := (others => '0');
signal rp_cntr_que : std_logic_vector(3 downto 0) := (others => '0');
signal rst_counter : std_logic := '0';
signal we_counter : std_logic := '0';
signal cntr_busy : std_logic := '0';
signal carry_out : std_logic := '0';
signal carry_in : std_logic := '0';
signal sum : std_logic_vector(32 downto 0) := (others => '0');
signal counter_do : std_logic_vector(31 downto 0) := (others => '0');
signal inc_counter : std_logic_vector(2 downto 0) := (others => '0');
signal sel : std_logic_vector(15 downto 0) := (others => '0');
signal counter_di : std_logic_vector(31 downto 0) := (others => '0');
signal cntr_que_out_l : std_logic_vector(25 downto 0) := (others => '0');
signal counter_wa : std_logic_vector(8 downto 0) := (others => '0');
signal rd_counters_n : std_logic := '0';
signal ev_cntr : std_logic_vector(7 downto 0) := (others => '0');
signal ev_cntrp : std_logic_vector(7 downto 0) := (others => '0');
signal d_ev_cntr : std_logic_vector(7 downto 0) := (others => '0');
signal ev_cntr_a : std_logic_vector(3 downto 0) := (others => '0');
signal we_ev_cntr : std_logic := '0';
begin
lrb_test_str <= ec_lfsr;
lrb_test_data <= lfsr;
event_data <= eoe & lrb_event_data(31 downto 0);
wp_addr <= wp_addr_i;
re_event_info <= re_event_info_i;
re_event_data <= re_event_data_i;
debug <= reg_data;
process(clk)
begin
  if(clk'event and clk = '1')then
    strobe <= n_strobe;
		lrb_event_data <= lrb0_event_data or lrb1_event_data or lrb2_event_data or lrb3_event_data or lrb4_event_data;
		lrb_event_info <= lrb0_event_info or lrb1_event_info or lrb2_event_info or lrb3_event_info or lrb4_event_info;
		if(strobe = '1')then
			if(lrb_test = '0')then
				lfsr <= (others => '0');
			elsif(ec_lfsr = '1')then
				lfsr <= lfsr(30 downto 0) & not(lfsr(31) xor lfsr(21) xor lfsr(1) xor lfsr(0));
			end if;
			if(lrb_test = '0' or ec_lfsr = '1' or or_reduce(lrb_err) = '1' or lfsr_cntr(CONV_INTEGER(test_ctrl)+32) = '1')then
				ec_lfsr <= '0';
			elsif(and_reduce(lrb_ack_l) = '1')then
				ec_lfsr <= '1';
			end if;
			if(lrb_test = '0')then
				lfsr_cntr <= (others => '0');
			elsif(ec_lfsr = '1')then
				lfsr_cntr <= lfsr_cntr + 1;
			end if;
			if(lrb_test = '0')then
				lrb_ack_l <= (others => '1');
			elsif(ec_lfsr = '1')then
				lrb_ack_l <= (others => '0');
			else
				lrb_ack_l <= lrb_ack_l or lrb_ack;
			end if;
			if(lrb_test = '0')then
				event_data_req <= lrb_ch(1 downto 0) & htr_buf_addr(7 downto 0) & htr_buf_length(8 downto 0);
			else
				event_data_req <= lfsr_cntr(18 downto 9) & "111111111";
			end if;
			if(lrb_test = '1')then
				if(and_reduce(lfsr_cntr(8 downto 0)) = '1' and ec_lfsr = '1')then
					event_data_req_str <= (others => '1');
				else
					event_data_req_str <= (others => '0');
				end if;
			elsif(htr_buf_req = '0')then
				event_data_req_str <= (others => '0');
			else
				case lrb_ch(4 downto 2) is
					when "000" => event_data_req_str(0) <= '1';
					when "001" => event_data_req_str(1) <= '1';
					when "010" => event_data_req_str(2) <= '1';
					when "011" => event_data_req_str(3) <= '1';
					when "100" => event_data_req_str(4) <= '1';
					when others => event_data_req_str <= (others => '0');
				end case;
			end if;
			if(lrb_test = '1')then
				htr_buf_que_in <= x"0" & lfsr_cntr(2 downto 0) & "111111111";
				if(ec_lfsr = '1' and and_reduce(lfsr_cntr(8 downto 3)) = '1' and (lfsr_cntr(2) = '0' or lfsr_cntr(1 downto 0) = "00"))then
					we_htr_buf_que <= '1';
				else
					we_htr_buf_que <= '0';
				end if;
			else
				htr_buf_que_in <= htr_buf_addr(11 downto 8) & lrb_ch(4 downto 2) & htr_buf_length(8 downto 0);
				we_htr_buf_que <= htr_buf_req;
			end if;
		end if;
	end if;
end process;
i_htr_buf_que : srl_fifo32
  generic map (N => 16)
  port map(
	rst => reset,
	din => htr_buf_que_in,
	clk => clk,
	w_strobe => strobe,
	we => we_htr_buf_que,
	r_strobe => '1',
	re => re_htr_buf_que,
	dav => dav_htr_buf_que,
	dout => htr_buf_que_out);
process(clk)
begin
  if(clk'event and clk = '1')then
		if(reset = '1')then
			re_htr_buf_que <= '0';
		elsif(dav_htr_buf_que = '1' and or_reduce(rd_event_data) = '0' and cntr_que_afull = '0' and (htr_rd_cntr(4) = '1' or lrb_test = '1'))then
			case htr_buf_que_out(11 downto 9) is
				when "000" => re_htr_buf_que <= event_data_rdy(0);
				when "001" => re_htr_buf_que <= event_data_rdy(1);
				when "010" => re_htr_buf_que <= event_data_rdy(2);
				when "011" => re_htr_buf_que <= event_data_rdy(3);
				when others => re_htr_buf_que <= event_data_rdy(4);
			end case;
		else
			re_htr_buf_que <= '0';
		end if;
		if(or_reduce(rd_event_data) = '0')then
			rd_wc <= not htr_buf_que_out(8 downto 0);
		elsif(event_buf_afull = '0')then
			rd_wc <= rd_wc + 1;
		end if;
		if(reset = '1' or or_reduce(rd_event_data) = '0' or event_buf_afull = '1')then
			rd_evt_data <= '0';
		else
			rd_evt_data <= '1';
		end if;
		if(or_reduce(rd_event_data) = '0')then
			rd_idle <= '1';
		else
			rd_idle <= '0';
		end if;
		if(rd_idle = '1')then
			rd_next_event <= rd_event_data;
		else
			rd_next_event <= (others => '0');
		end if;
		if(reset = '1')then
			rd_event_data <= (others => '0');
		elsif(dav_htr_buf_que = '1' and or_reduce(rd_event_data) = '0' and cntr_que_afull = '0' and (htr_rd_cntr(4) = '1' or lrb_test = '1'))then
			case htr_buf_que_out(11 downto 9) is
				when "000" => rd_event_data(0) <= event_data_rdy(0);
				when "001" => rd_event_data(1) <= event_data_rdy(1);
				when "010" => rd_event_data(2) <= event_data_rdy(2);
				when "011" => rd_event_data(3) <= event_data_rdy(3);
				when others => rd_event_data(4) <= event_data_rdy(4);
			end case;
		elsif(and_reduce(rd_wc) = '1' and event_buf_afull = '0')then
			rd_event_data <= (others => '0');
		end if;
		if(reset = '1')then
			htr_rd_cntr <= (others => '0');
		elsif(htr_rd_cnt_str = '1')then
			htr_rd_cntr <= '1' & not htr_rd_cnt;
		elsif(re_htr_buf_que = '1')then
			htr_rd_cntr <= htr_rd_cntr + 1;
		end if;
		rd_evt_data_dl <= rd_evt_data;
		check_data <= rd_evt_data_dl;
		event_data_val <= rd_evt_data_dl and not lrb_test;
		if(reset = '1' or event_buf_afull = '1')then
			re_event_data_i <= (others => '0');
		else
			re_event_data_i <= rd_event_data;
		end if;
		if(rd_evt_data = '1' and or_reduce(rd_wc) = '0' and reset = '0')then
			end_of_event <= '1';
		else
			end_of_event <= '0';
		end if;
		check_crc <= end_of_event and not reset;
		eoe <= end_of_event;
		save_lfsr <= check_crc and lrb_num(2) and lrb_test;
		if(lrb_test = '0')then
			saved_lfsr2 <= (others => '0');
		elsif(save_lfsr = '1')then
			saved_lfsr2 <= lfsr2;
		end if;
		if(lrb_test = '0' or (check_crc = '1' and lrb_num(2) = '0'))then
			lfsr2 <= saved_lfsr2;
		elsif(check_data = '1')then
			lfsr2 <= lfsr2(30 downto 0) & not(lfsr2(31) xor lfsr2(21) xor lfsr2(1) xor lfsr2(0));
		end if;
		if(lrb_test = '0')then
			lfsr2_cntr <= (others => '0');
		elsif(check_data = '1')then
			lfsr2_cntr(8 downto 0) <= lfsr2_cntr(8 downto 0) + 1;
			if(lrb_num(2) = '1' and and_reduce(lfsr2_cntr(8 downto 0)) = '1')then
				lfsr2_cntr(31 downto 9) <= lfsr2_cntr(31 downto 9) + 1;
			end if;
		end if;
		if(re_htr_buf_que = '1')then
			lrb_nump <= htr_buf_que_out(15 downto 9);
		end if;
	end if;
end process;
g_lrb_num: for i in lrb_num'range generate
	i_lrb_num: delayN generic map(N=> 2) port map(d => lrb_nump(i), ce => '1', c => clk, q => lrb_num(i));
end generate;
process(clk)
begin
  if(clk'event and clk = '1')then
		check_lfsr <= check_data;
		if(lrb_event_data(31 downto 16) = lfsr2(31 downto 16))then
			h_equal <= '1';
		else
			h_equal <= '0';
		end if;
		if(lrb_event_data(15 downto 0) = lfsr2(15 downto 0))then
			l_equal <= '1';
		else
			l_equal <= '0';
		end if;
		if(reset = '1')then
			lrb_err <= (others => '0');
		elsif(check_lfsr = '1' and (h_equal = '0' or l_equal = '0'))then
			case lrb_num(2 downto 0) is
				when "000" => lrb_err(0) <= '1';
				when "001" => lrb_err(1) <= '1';
				when "010" => lrb_err(2) <= '1';
				when "011" => lrb_err(3) <= '1';
				when others => lrb_err(4) <= '1';
			end case;
		end if;
	end if;
end process;
g_ev_info_dl: for i in 0 to 31 generate
	i_ev_info_dl: delayN generic map(N=> 2) port map(d => lrb_event_info(i), ce => '1', c => clk, q => ev_info_dl(i));
end generate;
i_wp_a: ram16XNd
    generic map( N => 9)
    port map(
        clk => clk,
        we => we_wp, 
        d => wp_plus_one,
        a => lrb_wa(3 downto 0),
        dpra => rp_addr,
        spo => spo_wp,
        dpo => d_dpo_wp);			
i_wp_b: ram16XNd
    generic map( N => 9)
    port map(
        clk => clk,
        we => we_wp, 
        d => wp_plus_one,
        a => lrb_wa(3 downto 0),
        dpra => wp_addr_i,
        dpo => wp);			
process(clk)
begin
  if(clk'event and clk = '1')then
		if(rst_cycle = '1')then
			htr_buf_ovf <= (others => '0');
		elsif(we_wp = '1' and rp(8) /= spo_wp(8) and rp(7 downto 0) = spo_wp(7 downto 0))then
			htr_buf_ovf(CONV_INTEGER(lrb_wa(3 downto 0))) <= '1';
		end if;
		if(strobe = '1')then
			dpo_wp <= d_dpo_wp;
		end if;
		lrb_offset(3) <= event_info_val(4) or event_info_val(3);
		lrb_offset(2) <= event_info_val(4) or event_info_val(2);
		lrb_offset(1) <= event_info_val(2) or event_info_val(1);
		lrb_offset(0) <= event_info_val(3) or event_info_val(1);
		if(rst_cycle = '1')then
			wp_plus_one <= (others => '0');
		else
			wp_plus_one <= wp + 1;
		end if;
		last_info <= lrb_event_info(32);
		we_wpp <= we_ev_info or rst_cycle;
		we_wp <= rst_cycle or (we_wpp and last_info);
		if(rst_cycle = '1')then
			wp_addr_i <= wp_addr_i + 1;
		else
			wp_addr_i <= lrb_offset + ("00" & lrb_event_info(25 downto 24));
		end if;
		if(reset = '1' and strobe = '1')then
			info_buf_wa <= (others => '0');
		elsif(we_ev_info = '1')then
			info_buf_wa <= info_buf_wa + 1;
		end if;
		if(or_reduce(re_event_info_i) = '1')then
			rd_info_busy <= '1';
		else
			rd_info_busy <= '0';
		end if;
		if(or_reduce(re_event_info_i) = '0' and or_reduce(event_info_val) = '0' and rd_info_busy = '0')then
			if(event_info_rdy(0) = '1')then
				re_event_info_i <= "00001";
			elsif(event_info_rdy(1) = '1')then
				re_event_info_i <= "00010";
			elsif(event_info_rdy(2) = '1')then
				re_event_info_i <= "00100";
			elsif(event_info_rdy(3) = '1')then
				re_event_info_i <= "01000";
			elsif(event_info_rdy(4) = '1')then
				re_event_info_i <= "10000";
			else
				re_event_info_i <= (others => '0');
			end if;
		else
			re_event_info_i <= (others => '0');
		end if;
		if(reset = '1' or or_reduce(event_info_val) = '0')then
			we_ev_info <= '0';
		else
			we_ev_info <= '1';
		end if;
		lrb_data_dl <= lrb_event_data;
		lfsr2_dl <= lfsr2;
		if(or_reduce(lrb_err) = '0')then
			err_loc <= lrb_num(2 downto 0) & re_event_data_i(4 downto 0) & lfsr2_cntr(23 downto 0);
			err_data <= lrb_data_dl(31 downto 0);
			err_lfsr2 <= lfsr2_dl;
		end if;
	end if;
end process;
i_info_wc: ram16XNs
    generic map( N => 2)
    port map(
        clk => clk,
        we => we_wpp, 
        d => d_info_wc,
        a => wp_addr_i,
        o => info_wc);			
d_info_wc(1) <= '1' when last_info = '0' and rst_cycle_dl = '0' and info_wc(1) /= info_wc(0) else '0';
d_info_wc(0) <= '1' when last_info = '0' and rst_cycle_dl = '0' and info_wc(0) = '0' else '0';
process(clk)
begin
  if(clk'event and clk = '1')then
		rst_cycle_dl <= rst_cycle;
		last_lrb_ch <= lrb_event_info(25 downto 24);
		if(last_lrb_ch = lrb_event_info(25 downto 24) and last_info = '1')then
			sel_wp_plus_one <= '1';
		else
			sel_wp_plus_one <= '0';
		end if;
		if(sel_wp_plus_one = '1')then
			lrb_wa <= wp_plus_one(7 downto 0) & wp_addr_i;
		else
			lrb_wa <= wp(7 downto 0) & wp_addr_i;
		end if;
		if(last_info = '0' and info_wc = "00" and we_wpp = '1')then
			wr_evn <= '1';
		else
			wr_evn <= '0';
		end if;
		if(last_info = '0' and info_wc = "01" and we_wpp = '1')then
			wr_htrstatus <= '1';
		else
			wr_htrstatus <= '0';
		end if;
		if(last_info = '0' and info_wc = "10" and we_wpp = '1')then
			wr_bcn <= '1';
		else
			wr_bcn <= '0';
		end if;
		if(lrb_event_info(32) = '0' and lrb_event_info(15) = '1')then
			htr_err <= '1';
		else
			htr_err <= '0';
		end if;
		if(htr_err = '1' and info_wc = "01" and we_wpp = '1')then
			chk_htrstatus <= '1';
		else
			chk_htrstatus <= '0';
		end if;
	end if;
end process;
htr_status_in <= lrb_wa(3 downto 0) & ev_info_dl(14 downto 0);
i_HTRstatus: HTRstatus PORT MAP(
		reset => reset,
		rst_cycle => rst_cycle,
		clk => clk,
		strobe => strobe,
		addr => addr,
		we_byte => we_byte,
		w_data => w_data,
		wr_htr_status => chk_htrstatus,
		htr_status_in => htr_status_in,
		state_LUT => htr_state_LUT,
		HTR_ow => HTR_ow,
		HTR_bz => HTR_bz,
		HTR_state => HTR_state
	);
evn_in <= ev_info_dl(31 downto 26) & ev_info_dl(9 downto 8) & ev_info_dl(23 downto 16) & ev_info_dl(7 downto 0);
g_evn: for i in 0 to 5 generate
	i_evn: RAMB16_S4_S4 generic map(SIM_COLLISION_CHECK => "NONE")
   port map (
      DOB => lrb_evn(4*i+3 downto 4*i),      -- Port B 4-bit Data Output
      ADDRA => lrb_wa,  -- Port A 12-bit Address Input
      ADDRB => evn_ra,  -- Port B 12-bit Address Input
      CLKA => clk,    -- Port A Clock
      CLKB => clk,    -- Port B Clock
      DIA => evn_in(4*i+3 downto 4*i),      -- Port A 4-bit Data Input
      DIB => x"0",      -- Port B 4-bit Data Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => strobe,      -- Port B RAM Enable Input
      SSRA => '0',    -- Port A Synchronous Set/Reset Input
      SSRB => '0',    -- Port B Synchronous Set/Reset Input
      WEA => wr_evn,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
end generate;
g_bcn: for i in 0 to 2 generate
	i_bcn: RAMB16_S4_S4 generic map(SIM_COLLISION_CHECK => "NONE")
   port map (
      DOB => lrb_evn(4*i+27 downto 4*i+24),      -- Port B 4-bit Data Output
      ADDRA => lrb_wa,  -- Port A 12-bit Address Input
      ADDRB => evn_ra,  -- Port B 12-bit Address Input
      CLKA => clk,    -- Port A Clock
      CLKB => clk,    -- Port B Clock
      DIA => ev_info_dl(4*i+3 downto 4*i),      -- Port A 4-bit Data Input
      DIB => x"0",      -- Port B 4-bit Data Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => strobe,      -- Port B RAM Enable Input
      SSRA => '0',    -- Port A Synchronous Set/Reset Input
      SSRB => '0',    -- Port B Synchronous Set/Reset Input
      WEA => wr_bcn,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
end generate;
lrb_evn(40 downto 36) <= htr_oc(7 downto 3);
g_oc: for i in 0 to 1 generate
	i_oc: RAMB16_S4_S4 generic map(SIM_COLLISION_CHECK => "NONE")
   port map (
      DOB => htr_oc(4*i+3 downto 4*i),      -- Port B 4-bit Data Output
      ADDRA => lrb_wa,  -- Port A 12-bit Address Input
      ADDRB => evn_ra,  -- Port B 12-bit Address Input
      CLKA => clk,    -- Port A Clock
      CLKB => clk,    -- Port B Clock
      DIA => ev_info_dl(4*i+27 downto 4*i+24),      -- Port A 4-bit Data Input
      DIB => x"0",      -- Port B 4-bit Data Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => strobe,      -- Port B RAM Enable Input
      SSRA => '0',    -- Port A Synchronous Set/Reset Input
      SSRB => '0',    -- Port B Synchronous Set/Reset Input
      WEA => wr_htrstatus,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
end generate;
g_htrstatus: for i in 0 to 1 generate
	i_htrstatus: RAMB16_S4_S4 generic map(SIM_COLLISION_CHECK => "NONE")
   port map (
      DOB => summary(4*i+27 downto 4*i+24),      -- Port B 4-bit Data Output
      ADDRA => lrb_wa,  -- Port A 12-bit Address Input
      ADDRB => smry_ra,  -- Port B 12-bit Address Input
      CLKA => clk,    -- Port A Clock
      CLKB => clk,    -- Port B Clock
      DIA => ev_info_dl(4*i+3 downto 4*i),      -- Port A 4-bit Data Input
      DIB => x"0",      -- Port B 4-bit Data Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => strobe,      -- Port B RAM Enable Input
      SSRA => '0',    -- Port A Synchronous Set/Reset Input
      SSRB => '0',    -- Port B Synchronous Set/Reset Input
      WEA => wr_htrstatus,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
end generate;
trailer_in <= '0' & cal_trig & ev_info_dl(23 downto 16) & ev_info_dl(9 downto 0);
i_cal_trig: ram16X1S
   port map (
      O => cal_trig,       -- RAM output
      A0 => lrb_wa(0),     -- RAM address(0) input
      A1 => lrb_wa(1),     -- RAM address(1) input
      A2 => lrb_wa(2),     -- RAM address(2) input
      A3 => lrb_wa(3),     -- RAM address(3) input
      D => ev_info_dl(14),       -- RAM data input
      WCLK => clk, -- Write clock input
      WE => wr_htrstatus);      -- Write enable input
g_trailer: for i in 0 to 4 generate
	i_trailer: RAMB16_S4_S4 generic map(SIM_COLLISION_CHECK => "NONE")
   port map (
      DOB => trailer(4*i+3 downto 4*i),      -- Port B 4-bit Data Output
      ADDRA => lrb_wa,  -- Port A 12-bit Address Input
      ADDRB => smry_ra,  -- Port B 12-bit Address Input
      CLKA => clk,    -- Port A Clock
      CLKB => clk,    -- Port B Clock
      DIA => trailer_in(4*i+3 downto 4*i),      -- Port A 4-bit Data Input
      DIB => x"0",      -- Port B 4-bit Data Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => strobe,      -- Port B RAM Enable Input
      SSRA => '0',    -- Port A Synchronous Set/Reset Input
      SSRB => '0',    -- Port B Synchronous Set/Reset Input
      WEA => we_wp,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
end generate;
summary(23 downto 16) <= trailer(17 downto 10); -- lrb_err
summary(15) <= trailer(18); -- calibration trigger
summary(14 downto 12) <= "100"; -- EPV
summary(11) <= trailer(12); -- truncate error
summary(10) <= trailer(14); -- LRB CRC error
summary(9 downto 0) <= trailer(9 downto 0); -- event length
i_crc: crc16D32 PORT MAP(
		clk => clk,
		init_crc => init_crc,
		we_crc => check_data,
		d => crc_data,
		crc => crc
	);
crc_data <= crc_data_h & lrb_event_data(15 downto 0);
i_init_crc: delayN generic map(N=> 2) port map(d => re_htr_buf_que, ce => '1', c => clk, q => set_init_crc);
process(clk)
begin
  if(clk'event and clk = '1')then
		if(set_init_crc = '1')then
			init_crc <= '1';
		elsif(check_data = '1')then
			init_crc <= '0';
		end if;
		if(check_data = '1')then
			crc_data_h <= lrb_event_data(31 downto 16);
		end if;
		if(check_crc = '1' and crc /= crc_data(31 downto 16) and lrb_test = '0')then
			crc_err <= '1';
		else
			crc_err <= '0';
		end if;
		if(lrb_test = '1')then
			header_cntr <= "100";
		elsif(init_crc = '1')then
			header_cntr <= (others => '0');
		elsif(header_cntr(2) = '0' and check_lfsr = '1')then
			header_cntr <= header_cntr + 1;
		end if;
--		if(lrb_event_data(15) = '0' or lrb_event_data(14) = '1' or or_reduce(lrb_event_data(12 downto 0)) = '1')then -- modified for dsp_chip301e
		if(check_data = '1' and (lrb_event_data(15) = '0' or lrb_event_data(14) = '1' or or_reduce(lrb_event_data(12 downto 0)) = '1'))then
			ec_htr_status <= '1';
		else
			ec_htr_status <= '0';
		end if;
		check_US <= check_data and lrb_event_data(15);
		if(init_crc = '1')then
			cntr_que_din(25 downto 16) <= "0000000000";
		elsif(check_lfsr = '1' and (lrb_test = '0' or h_equal = '0' or l_equal = '0'))then
			cntr_que_din(25 downto 16) <= cntr_que_din(25 downto 16) + 1;
		end if;
		cntr_que_din(26) <= check_crc_dl;
		cntr_que_din(30 downto 27) <= lrb_num(6 downto 3);
		check_crc_dl <= check_crc and not reset;
		if(check_crc_dl = '1')then
			cntr_que_din(15 downto 10) <= "000001";
			cntr_que_din(9) <= crc_err xor lrb_data_dl(20); -- crc error different from that of LRB
			cntr_que_din(8) <= crc_err;
			cntr_que_din(7 downto 0) <= lrb_data_dl(23 downto 16);
		elsif(header_cntr(1 downto 0) = "11")then
			cntr_que_din(15 downto 0) <= x"8000";
		elsif(lrb_data_dl(15) = '1')then
			cntr_que_din(15 downto 0) <= '0' & lrb_data_dl(12 downto 9) & lrb_data_dl(14) & '0' & lrb_data_dl(8 downto 0);
		else
			cntr_que_din(15 downto 0) <= x"0200";
		end if;
--		if((check_crc_dl = '1' or (header_cntr(1 downto 0) = "11" and lrb_data_dl(15) = '1') or (header_cntr(1 downto 0) = "01" and ec_htr_status = '1')) and reset = '0')then -- modified for dsp_chip301e
		if((check_crc_dl = '1' or (header_cntr(1 downto 0) = "11" and check_US = '1') or (header_cntr(1 downto 0) = "01" and ec_htr_status = '1')) and reset = '0')then
			we_cntr_que <= '1';
		else
			we_cntr_que <= '0';
		end if;
--		if(reset = '1' or rp_cntr_que(3) = '0')then
		if(dav_cntr_que = '0')then -- modified from dsp_chip301e
			cntr_que_afull <= '0';
--		elsif(rp_cntr_que(2) = '0')then
		elsif(rp_cntr_que(3 downto 2) = "10")then -- modified from dsp_chip301e
			cntr_que_afull <= '1';
		end if;
	end if;
end process;
--i_ev_cntr: ram16XNd
--    generic map( N => 8)
--    port map(
--        clk => clk,
--        we => we_ev_cntr, 
--        d => d_ev_cntr,
--        a => ev_cntr_a,
--        dpra => addr(3 downto 0),
--        spo => ev_cntrp,
--        dpo => ev_cntr);			
--d_ev_cntr <= x"00" when rst_cycle = '1' else ev_cntrp + 1;
--we_ev_cntr <= rst_cycle or (we_cntr_que and cntr_que_din(26));
--ev_cntr_a <= wp_addr_i when rst_cycle = '1' else cntr_que_din(30 downto 27);
i_cntr_que : srl_fifo
  generic map (N => 31)
  port map(
	rst => reset,
	din => cntr_que_din,
	clk => clk,
	w_strobe => '1',
	we => we_cntr_que,
	r_strobe => '1',
	re => re_cntr_que,
	dav => dav_cntr_que,
	dout => cntr_que_dout,
	rp => rp_cntr_que);
process(clk)
begin
  if(clk'event and clk = '1')then
		if(cntr_busy = '0' and rst_counter = '0' and dav_cntr_que = '1')then
			re_cntr_que <= '1';
			cntr_busy <= '1';
		else	
			re_cntr_que <= '0';
			if(or_reduce(cntr_que_out_l(15 downto 0)) = '0' and (counter_wa(4) = '1' or sel(10) = '0'))then	
				cntr_busy <= '0';
			end if;
		end if;
		if(reset = '1')then
			rst_cycle <= '1';
		elsif(counter_wa(0) = '1')then
			rst_cycle <= '0';
		end if;
		if(reset = '1')then
			rst_counter <= '1';
		elsif(counter_wa = ('1' & x"bf"))then
			rst_counter <= '0';
		end if;
		if(reset = '1')then
			counter_wa(8 downto 4) <= "00000";
		elsif(rst_counter = '1')then
		  if(counter_wa(8 downto 5) = x"e")then
				counter_wa(8 downto 5) <= x"0";
				if(counter_wa(3 downto 0) = x"d")then
					counter_wa(4) <= '1';
				end if;
			else
				counter_wa(8 downto 5) <= counter_wa(8 downto 5) + 1;
			end if;
		elsif(cntr_busy = '0')then
			counter_wa(4) <= not cntr_que_dout(26);
			counter_wa(8 downto 5) <= cntr_que_dout(30 downto 27);
		end if;
		if(rst_counter = '1')then
			inc_counter <= (others => '0');
		else
			inc_counter(0) <= re_cntr_que or inc_counter(2);
			if(or_reduce(sel) = '0')then
				inc_counter(2 downto 1) <= "00";
			else
				inc_counter(2 downto 1) <= inc_counter(1 downto 0);
			end if;
		end if;
		if(cntr_busy = '0')then
			carry_in <= '1';
		elsif(we_counter = '1')then
			carry_in <= carry_out or not sel(10) or counter_wa(0);
		end if;
		if(rst_counter = '1')then
			we_counter <= '1';
		else
			we_counter <= inc_counter(2);
		end if;
		if(rst_counter = '1')then
			sum <= (others => '0');
		elsif(counter_wa(4 downto 0) = "01010")then
			sum <= ('0' & counter_do) + ("000" & x"00000" & cntr_que_out_l(25 downto 16));
		else
			sum <= ('0' & counter_do) + (x"00000000" & carry_in);
		end if;
		if(cntr_busy = '0')then
			cntr_que_out_l <= cntr_que_dout(25 downto 0);
		elsif(inc_counter(1) = '1')then
			cntr_que_out_l(15 downto 0) <= cntr_que_out_l(15 downto 0) and not sel(15 downto 0);
		end if;
		if(cntr_busy = '0')then
			sel <= x"0000";
		elsif(cntr_que_out_l(0) = '1')then
			sel <= x"0001";
		elsif(cntr_que_out_l(1) = '1')then
			sel <= x"0002";
		elsif(cntr_que_out_l(2) = '1')then
			sel <= x"0004";
		elsif(cntr_que_out_l(3) = '1')then
			sel <= x"0008";
		elsif(cntr_que_out_l(4) = '1')then
			sel <= x"0010";
		elsif(cntr_que_out_l(5) = '1')then
			sel <= x"0020";
		elsif(cntr_que_out_l(6) = '1')then
			sel <= x"0040";
		elsif(cntr_que_out_l(7) = '1')then
			sel <= x"0080";
		elsif(cntr_que_out_l(8) = '1')then
			sel <= x"0100";
		elsif(cntr_que_out_l(9) = '1')then
			sel <= x"0200";
		elsif(cntr_que_out_l(10) = '1')then
			sel <= x"0400";
		elsif(cntr_que_out_l(11) = '1')then
			sel <= x"0800";
		elsif(cntr_que_out_l(12) = '1')then
			sel <= x"1000";
		elsif(cntr_que_out_l(13) = '1')then
			sel <= x"2000";
		elsif(cntr_que_out_l(14) = '1')then
			sel <= x"4000";
		elsif(cntr_que_out_l(15) = '1')then
			sel <= x"8000";
		elsif(sel(10) = '1' and counter_wa(4) = '0' )then
			if(counter_wa(3 downto 2) = "11" and (counter_wa(0) = '1' or carry_out = '0') and we_counter = '1')then
				sel <= x"0000";
			end if;
		else
			sel <= x"0000";
		end if;
		if(rst_counter = '1')then
			if(counter_wa(8 downto 5) = x"e")then
				if(counter_wa(3 downto 0) = x"d" and counter_wa(4) = '0')then
					counter_wa(3 downto 0) <= x"0";
				else
					counter_wa(3 downto 0) <= counter_wa(3 downto 0) + 1;
				end if;
			end if;
		elsif(sel(10) = '1' and counter_wa(4 downto 3) = "01" and counter_wa(2 downto 1) /= "00")then
			if(inc_counter(0) = '1')then
				counter_wa(3 downto 0) <= counter_wa(3 downto 0) + 1;
			end if;
		else
			counter_wa(3) <= sel(15) or sel(14) or sel(13) or sel(12) or sel(11) or sel(10) or sel(9) or sel(8);
			counter_wa(2) <= sel(15) or sel(14) or sel(13) or sel(12) or sel(7) or sel(6) or sel(5) or sel(4);
			counter_wa(1) <= sel(15) or sel(14) or sel(11) or sel(10) or sel(7) or sel(6) or sel(3) or sel(2);
			counter_wa(0) <= sel(15) or sel(13) or sel(11) or sel(9) or sel(7) or sel(5) or sel(3) or sel(1);
		end if;
		if(strobe = '1')then
			if(addr(14 downto 6) /= debug_addr(14 downto 6))then
				reg_data <= (others => '0');
			else
--				reg_data <= x"000000" & ev_cntr;
				case addr(3 downto 0) is
					when x"0" => reg_data <= lfsr2_cntr;
					when x"1" => reg_data <= "000" & lrb_err & "00" & event_data_rdy & save_lfsr & check_data & rd_evt_data & rd_event_data & rd_wc;
					when x"2" => reg_data <= err_loc;
					when x"3" => reg_data <= "11" & x"c0" & ec_lfsr & lrb_ack_l & lfsr_cntr(15 downto 0);
					when x"4" => reg_data <= cntr_que_afull & lrb_nump & dav_htr_buf_que & lrb_num & htr_buf_que_out(15 downto 0);
					when x"5" => reg_data <= err_data;
--					when x"6" => reg_data <= "100" & re_event_info & "000" & event_info_rdy & "0000000" & info_buf_wa(8 downto 0);
					when x"6" => reg_data <= err_lfsr2;
					when x"7" => reg_data <= lfsr_cntr(47 downto 16);
--					when x"8" => reg_data <= ofw_htr_buf_que & "000" & x"000" & max_htr_buf(15 downto 0);
--					when x"8" => reg_data <= ofw_htr_buf_que & "000" & x"0000000";
					when others => reg_data <= (others => '0');
				end case;
			end if;
		end if;
	end if;
end process;
counter_di <= sum(31 downto 0);
carry_out <= sum(32);
i_counter: RAMB16_S36_S36 generic map(SIM_COLLISION_CHECK => "NONE")
   port map (
      DOA => counter_do,      -- Port A 32-bit Data Output
      DOB => counters,      -- Port B 32-bit Data Output
      ADDRA => counter_wa,  -- Port A 9-bit Address Input
      ADDRB => addr(8 downto 0),  -- Port B 9-bit Address Input
      CLKA => clk,    -- Port A Clock
      CLKB => clk,    -- Port B Clock
      DIA => counter_di,      -- Port A 32-bit Data Input
      DIB => x"00000000",      -- Port B 32-bit Data Input
      DIPA => x"0",    -- Port A 4-bit parity Input
      DIPB => x"0",    -- Port-B 4-bit parity Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => strobe,      -- PortB RAM Enable Input
      SSRA => '0',    -- Port A Synchronous Set/Reset Input
      SSRB => rd_counters_n,    -- Port B Synchronous Set/Reset Input
      WEA => we_counter,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
rd_counters_n <= '0' when addr(14 downto 9) = counter_addr(14 downto 9) else '1';
i_lrb_ch0: ROM16X1
   generic map (
      INIT => X"2492")
   port map (
      O => lrb_ch(0),   -- ROM output
      A0 => htr_buf_addr(8), -- ROM address[0]
      A1 => htr_buf_addr(9), -- ROM address[1]
      A2 => htr_buf_addr(10), -- ROM address[2]
      A3 => htr_buf_addr(11)  -- ROM address[3]
   );
i_lrb_ch1: ROM16X1
   generic map (
      INIT => X"4924")
   port map (
      O => lrb_ch(1),   -- ROM output
      A0 => htr_buf_addr(8), -- ROM address[0]
      A1 => htr_buf_addr(9), -- ROM address[1]
      A2 => htr_buf_addr(10), -- ROM address[2]
      A3 => htr_buf_addr(11)  -- ROM address[3]
   );
i_lrb_ch2: ROM16X1
   generic map (
      INIT => X"0e38")
   port map (
      O => lrb_ch(2),   -- ROM output
      A0 => htr_buf_addr(8), -- ROM address[0]
      A1 => htr_buf_addr(9), -- ROM address[1]
      A2 => htr_buf_addr(10), -- ROM address[2]
      A3 => htr_buf_addr(11)  -- ROM address[3]
   );
i_lrb_ch3: ROM16X1
   generic map (
      INIT => X"0fc0")
   port map (
      O => lrb_ch(3),   -- ROM output
      A0 => htr_buf_addr(8), -- ROM address[0]
      A1 => htr_buf_addr(9), -- ROM address[1]
      A2 => htr_buf_addr(10), -- ROM address[2]
      A3 => htr_buf_addr(11)  -- ROM address[3]
   );
i_lrb_ch4: ROM16X1
   generic map (
      INIT => X"7000")
   port map (
      O => lrb_ch(4),   -- ROM output
      A0 => htr_buf_addr(8), -- ROM address[0]
      A1 => htr_buf_addr(9), -- ROM address[1]
      A2 => htr_buf_addr(10), -- ROM address[2]
      A3 => htr_buf_addr(11)  -- ROM address[3]
   );
end Behavioral;

