`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   10:31:23 04/11/2009
// Design Name:   edc
// Module Name:   C:/iseproj/VME_dcc/DSP_dummy/edc_tb.v
// Project Name:  DSP_dummy
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: edc
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module edc_tb;

	// Inputs
	reg clk;
	reg n_strobe;
	reg reset;
	reg [15:0] addr;
	reg [31:0] w_data;
	reg [3:0] we_byte;
	reg [3:0] test_ctrl;
	reg lrb_test;
	reg [11:0] htr_buf_addr;
	reg [8:0] htr_buf_length;
	reg htr_buf_req;
	reg [4:0] event_data_rdy;
	reg [32:0] lrb0_event_data;
	reg [32:0] lrb1_event_data;
	reg [32:0] lrb2_event_data;
	reg [32:0] lrb3_event_data;
	reg [32:0] lrb4_event_data;
	reg [4:0] event_info_val;
	reg [4:0] event_info_rdy;
	reg [32:0] lrb0_event_info;
	reg [32:0] lrb1_event_info;
	reg [32:0] lrb2_event_info;
	reg [32:0] lrb3_event_info;
	reg [32:0] lrb4_event_info;
	reg event_buf_afull;
	reg [4:0] lrb_ack;
	reg [3:0] htr_rd_cnt;
	reg [3:0] rp_addr;
	reg [8:0] rp;
	reg htr_rd_cnt_str;
	reg [11:0] evn_ra;
	reg [11:0] smry_ra;
	reg [14:0] debug_addr;
	reg [14:0] counter_addr;

	// Outputs
	wire [3:0] wp_addr;
	wire [8:0] dpo_wp;
	wire [14:0] htr_buf_ovf;
	wire [4:0] re_event_data;
	wire [4:0] rd_next_event;
	wire [4:0] re_event_info;
	wire [4:0] event_data_req_str;
	wire [18:0] event_data_req;
	wire event_data_val;
	wire [32:0] event_data;
	wire lrb_test_str;
	wire [31:0] lrb_test_data;
	wire [31:0] debug;
	wire [31:0] summary;
	wire [40:0] lrb_evn;
	wire [31:0] counters;
	wire [31:0] htr_state_LUT;
	wire HTR_ow;
	wire HTR_bz;
	wire [1:0] HTR_state;

	// Instantiate the Unit Under Test (UUT)
	edc uut (
		.clk(clk), 
		.n_strobe(n_strobe), 
		.reset(reset), 
		.addr(addr), 
		.w_data(w_data), 
		.we_byte(we_byte), 
		.test_ctrl(test_ctrl), 
		.lrb_test(lrb_test), 
		.htr_buf_addr(htr_buf_addr), 
		.htr_buf_length(htr_buf_length), 
		.htr_buf_req(htr_buf_req), 
		.event_data_rdy(event_data_rdy), 
		.lrb0_event_data(lrb0_event_data), 
		.lrb1_event_data(lrb1_event_data), 
		.lrb2_event_data(lrb2_event_data), 
		.lrb3_event_data(lrb3_event_data), 
		.lrb4_event_data(lrb4_event_data), 
		.event_info_val(event_info_val), 
		.event_info_rdy(event_info_rdy), 
		.lrb0_event_info(lrb0_event_info), 
		.lrb1_event_info(lrb1_event_info), 
		.lrb2_event_info(lrb2_event_info), 
		.lrb3_event_info(lrb3_event_info), 
		.lrb4_event_info(lrb4_event_info), 
		.event_buf_afull(event_buf_afull), 
		.lrb_ack(lrb_ack), 
		.htr_rd_cnt(htr_rd_cnt), 
		.rp_addr(rp_addr), 
		.rp(rp), 
		.wp_addr(wp_addr), 
		.dpo_wp(dpo_wp), 
		.htr_buf_ovf(htr_buf_ovf), 
		.htr_rd_cnt_str(htr_rd_cnt_str), 
		.re_event_data(re_event_data), 
		.rd_next_event(rd_next_event), 
		.re_event_info(re_event_info), 
		.event_data_req_str(event_data_req_str), 
		.event_data_req(event_data_req), 
		.event_data_val(event_data_val), 
		.event_data(event_data), 
		.lrb_test_str(lrb_test_str), 
		.lrb_test_data(lrb_test_data), 
		.debug(debug), 
		.evn_ra(evn_ra), 
		.smry_ra(smry_ra), 
		.summary(summary), 
		.lrb_evn(lrb_evn), 
		.debug_addr(debug_addr), 
		.counter_addr(counter_addr), 
		.counters(counters), 
		.htr_state_LUT(htr_state_LUT), 
		.HTR_ow(HTR_ow), 
		.HTR_bz(HTR_bz), 
		.HTR_state(HTR_state)
	);

	initial begin
		// Initialize Inputs
		clk = 0;
		n_strobe = 0;
		reset = 0;
		addr = 0;
		w_data = 0;
		we_byte = 0;
		test_ctrl = 0;
		lrb_test = 0;
		htr_buf_addr = 0;
		htr_buf_length = 0;
		htr_buf_req = 0;
		event_data_rdy = 0;
		lrb0_event_data = 0;
		lrb1_event_data = 0;
		lrb2_event_data = 0;
		lrb3_event_data = 0;
		lrb4_event_data = 0;
		event_info_val = 0;
		event_info_rdy = 0;
		lrb0_event_info = 0;
		lrb1_event_info = 0;
		lrb2_event_info = 0;
		lrb3_event_info = 0;
		lrb4_event_info = 0;
		event_buf_afull = 0;
		lrb_ack = 0;
		htr_rd_cnt = 0;
		rp_addr = 0;
		rp = 0;
		htr_rd_cnt_str = 0;
		evn_ra = 0;
		smry_ra = 0;
		debug_addr = 0;
		counter_addr = 0;
		#13.5;
		reset = 1;
		#13.5;
		reset = 0;
		#2497.5;
		htr_buf_addr = 12'h000; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'h100; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'h200; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'h300; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'h400; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'h500; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'h600; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'h700; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'h800; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'h900; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'ha00; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'hb00; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'hc00; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'hd00; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'he00; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;
		htr_buf_addr = 12'hf00; 
		htr_buf_length = 10'h7; 
		htr_buf_req = 1;
		#13.32;
		htr_buf_req = 0; 
		#100;

		// Wait 100 ns for global reset to finish
        
		// Add stimulus here

	end
   always begin
      clk = 1'b0;
      #3.33 clk = 1'b1;
      #3.33;
   end  
always@(posedge clk)
	n_strobe <= ~n_strobe;
      
endmodule

