`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   12:24:13 06/05/2009
// Design Name:   ethernetnew
// Module Name:   C:/iseproj/VME_dcc/DSP_dummy/et_tb.v
// Project Name:  DSP_dummy
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: ethernetnew
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module et_tb;

	// Inputs
	reg clk;
	reg n_strobe;
	reg reset;
	reg addr_str;
	reg [7:0] mod_sn;
//	reg [3:0] we_byte;
	reg [31:0] r_data;
	reg ethernet_sel;
	reg r_data_val;
	reg [7:0] e_data_w5100;
	reg [7:0] MR = 0;
	reg [15:0] AR = 0;
	reg [7:0] CR = 0;
	reg [7:0] S0_CR = 0;
	reg [7:0] S0_SR = 0;
	reg [15:0] S0_TX_FSR = 0;
	reg [15:0] S0_TX_WR = 0;
	reg [15:0] S0_RX_RSR = 0;
	reg [15:0] S0_RX_RD = 0;
	reg [13:0] r_offset = 0;
	reg [13:0] s_offset = 0;
	reg [3:0] rd_cntr = 0;

	// Outputs
	wire e_csn;
	wire e_wrn;
	wire e_rdn;
	wire [1:0] e_addr;
	wire [15:0] ethernet_addr;
	wire [3:0] ethernet_rd_length;
	wire [31:0] ethernet_wdata;
	wire ethernet_read;
	wire ethernet_str;
	wire [31:0] debug;

	// Bidirs
	wire [7:0] e_data;

	// Instantiate the Unit Under Test (UUT)
	ethernetnew uut (
		.clk(clk), 
		.n_strobe(n_strobe), 
		.reset(reset), 
		.addr_str(addr_str), 
		.mod_sn(mod_sn), 
//		.we_byte(we_byte), 
		.r_data(r_data), 
		.e_csn(e_csn), 
		.e_wrn(e_wrn), 
		.e_rdn(e_rdn), 
		.e_addr(e_addr), 
		.e_data(e_data), 
		.ethernet_sel(r_data_val), 
		.ethernet_abort(1'b0), 
		.r_data_val(r_data_val), 
		.ethernet_addr(ethernet_addr), 
		.ethernet_rd_length(ethernet_rd_length), 
		.ethernet_wdata(ethernet_wdata), 
		.ethernet_read(ethernet_read), 
		.ethernet_str(ethernet_str), 
		.debug(debug)
	);
	initial begin
		// Initialize Inputs
		clk = 0;
		n_strobe = 0;
		reset = 0;
		addr_str = 0;
		mod_sn = 1;
//		we_byte = 0;
		r_data = 32'habcdef00;
		ethernet_sel = 0;
		r_data_val = 0;
		e_data_w5100 = 1;
		// Wait 100 ns for global reset to finish
		#102;
		addr_str = 1;
		#20;
		addr_str = 0;
		// Add stimulus here

	end
assign e_data = e_rdn ? 8'bZ : e_data_w5100;
   always begin
      clk = 1'b0;
      #5 clk = 1'b1;
      #5;
   end  
always@*
	if(e_addr == 0)
		e_data_w5100 <= MR;
	else if(e_addr == 1)
		e_data_w5100 <= AR[15:8];
	else if(e_addr == 2)
		e_data_w5100 <= AR[7:0];
	else if(e_addr == 3)begin
		if(AR == 16'h0401)
			e_data_w5100 <= S0_CR;
		if(AR == 16'h0403)
			e_data_w5100 <= S0_SR;
		if(AR == 16'h0420)
			e_data_w5100 <= S0_TX_FSR[15:8];
		if(AR == 16'h0421)
			e_data_w5100 <= S0_TX_FSR[7:0];
		if(AR == 16'h0424)
			e_data_w5100 <= S0_TX_WR[15:8];
		if(AR == 16'h0425)
			e_data_w5100 <= S0_TX_WR[7:0];
		if(AR == 16'h0426)
			e_data_w5100 <= S0_RX_RSR[15:8];
		if(AR == 16'h0427)
			e_data_w5100 <= S0_RX_RSR[7:0];
		if(AR == 16'h0428)
			e_data_w5100 <= S0_RX_RD[15:8];
		if(AR == 16'h0429)
			e_data_w5100 <= S0_RX_RD[7:0];
		if(AR[14:13] == 2'b11)
			case (AR[4:0])
				5'h00: e_data_w5100 <= 8'ha0;
				5'h01: e_data_w5100 <= 8'h00;
				5'h02: e_data_w5100 <= 8'h12;
				5'h03: e_data_w5100 <= 8'h34;
				5'h04: e_data_w5100 <= 8'h10;
				5'h05: e_data_w5100 <= 8'h20;
				5'h06: e_data_w5100 <= 8'h30;
				5'h07: e_data_w5100 <= 8'h40;
				5'h08: e_data_w5100 <= 8'h05;
				5'h09: e_data_w5100 <= 8'h00;
				5'h0a: e_data_w5100 <= 8'h80;
				5'h0b: e_data_w5100 <= 8'h00;
				5'h0c: e_data_w5100 <= 8'h00;
				5'h0d: e_data_w5100 <= 8'h16;
				5'h0e: e_data_w5100 <= 8'h0;
				5'h0f: e_data_w5100 <= 8'h00;
				5'h10: e_data_w5100 <= 8'ha0;
				5'h11: e_data_w5100 <= 8'h00;
				5'h12: e_data_w5100 <= 8'h12;
				5'h13: e_data_w5100 <= 8'h34;
				5'h14: e_data_w5100 <= 8'h56;
				5'h15: e_data_w5100 <= 8'h78;
				5'h16: e_data_w5100 <= 8'h9a;
				5'h17: e_data_w5100 <= 8'hbc;
				5'h18: e_data_w5100 <= 8'h05;
				5'h19: e_data_w5100 <= 8'h00;
				5'h1a: e_data_w5100 <= 8'h00;
				5'h1b: e_data_w5100 <= 8'h00;
				5'h1c: e_data_w5100 <= 8'h08;
				5'h1d: e_data_w5100 <= 8'h20;
				5'h1e: e_data_w5100 <= 8'h00;
				default: e_data_w5100 <= 8'h00;
			endcase
	end
always@(posedge clk)
	n_strobe <= ~n_strobe;
always@(posedge e_csn)
		if(e_addr == 0 && e_wrn == 0)
			MR <= e_data;
		else if(e_addr == 0 && e_rdn == 0)
			MR[7] <= 0;
always@(posedge e_csn)
		if(e_addr == 1 && e_wrn == 0)
			AR[15:8] <= e_data;
		else if(e_addr == 2 && e_wrn == 0)
			AR[7:0] <= e_data;
		else if(e_addr == 3 && MR == 3)
			AR <= AR + 1;
always@(posedge e_csn)
		if(e_addr == 3 && e_wrn == 0 && AR == 16'h0401)
			S0_CR <= e_data;
		else if(e_addr == 3 && e_rdn == 0 && AR == 16'h0401)
			S0_CR <= 0;
always@(posedge e_csn)
		if(e_addr == 3 && e_wrn == 0 && AR == 16'h0401 && e_data == 8'h10)
			S0_SR <= 8'h0;
		else if(e_addr == 3 && e_wrn == 0 && AR == 16'h0401 && S0_SR == 8'h0 && e_data == 8'h01)
			S0_SR <= 8'h13;
		else if(e_addr == 3 && e_wrn == 0 && AR == 16'h0401 && S0_SR == 8'h13 && e_data == 8'h02)
			S0_SR <= 8'h14;
		else if(e_addr == 3 && e_rdn == 0 && AR == 16'h0401 && S0_SR == 8'h14)
			S0_SR <= 8'h16;
		else if(e_addr == 3 && e_rdn == 0 && AR == 16'h0401 && S0_SR == 8'h16)
			S0_SR <= 8'h17;
always@(posedge e_csn)
		if(e_addr == 3 && AR == 16'h0420)
			S0_TX_FSR[15:8] <= S0_TX_FSR[15:8] ^ 8'h08;
always@(posedge e_csn)
		if(e_addr == 3 && AR == 16'h0427)
			S0_RX_RSR[7:0] <= S0_RX_RSR[7:0] ^ 8'h08;
always@(posedge e_csn)
		if(e_addr == 3 && AR == 16'h0424)
			S0_TX_WR[15:8] <= {2'b0,e_data[5:0]};
always@(posedge e_csn)
		if(e_addr == 3 && AR == 16'h0425)
			S0_TX_WR[7:0] <= e_data;
always@(posedge e_csn)
		if(e_addr == 3 && AR == 16'h0428)
			S0_RX_RD[15:8] <= {2'b0,e_data[13:0]};
always@(posedge e_csn)
		if(e_addr == 3 && AR == 16'h0429)
			S0_RX_RD[7:0] <= e_data;
always@(posedge clk)
	if(n_strobe == 0)
		if(ethernet_str == 1 && ethernet_read == 1)
			r_data_val <= 1;
		else if(rd_cntr == ethernet_rd_length || ethernet_rd_length == 0)
			r_data_val <= 0;
always@(posedge clk)
	if(n_strobe == 0)
		if(r_data_val == 0)
			rd_cntr <= 0;
		else
			rd_cntr <= rd_cntr + 1;
always@(posedge clk)
	if(n_strobe == 0)
		if(r_data_val == 1)
			r_data <= r_data + 1;
endmodule

