`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:44:10 03/24/2009 
// Design Name: 
// Module Name:    ethernet 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
// this module uses TCP only, with one socket
//////////////////////////////////////////////////////////////////////////////////
module ethernet(
    input clk,
    input n_strobe,
		input reset,
		input update_led,
		input addr_str,
		input vme_read,
		input vme_cycle,
    input [3:0] we_byte,
    input [31:0] w_data,
    input [7:0] mod_sn, // module serial number, used as LSB of MAC and IP address
    output reg e_csn = 1,
    output reg e_wrn = 1,
    output reg e_rdn = 1,
    output reg [1:0] e_addr,
    output reg e_resetn = 0,
    output reg [31:0] ethernet_data,
    output reg ethernet_dav,
    input [7:0] e_data_i,
    output reg [7:0] e_data_o,
		output reg t_e_data = 1, 
    input e_intn,
    input [15:0] addr,
    input [15:0] ethernet_addr,
    input bus_gnt,
    output bus_rqst
    );
reg strobe = 0;
wire start_dl;
reg w5100_rdy = 0;
reg [2:0] clk_div = 0;
reg e_cycle = 0;
reg start = 0;
reg stop = 0;
reg rd_eth = 0;
	always@(posedge clk)
		if(strobe == 1)
			if(addr_str == 1 && vme_cycle == 1)
				e_addr <= addr[1:0];
	always@(posedge clk)
		strobe <= n_strobe;
	always@(posedge clk)
		if(strobe == 1 && update_led == 1) begin
			e_resetn <= 1;
			w5100_rdy <= e_resetn;
		end
	always@(posedge clk)
		if(strobe == 1)
			if(reset == 1)
				e_csn <= 1;
			else if(((addr_str == 1 && vme_cycle == 1 && vme_read == 1) || we_byte[3] == 1) && addr[14:2] == ethernet_addr[14:2])
				e_csn <= 0;
			else if(stop == 1)
				e_csn <= 1;
	always@(posedge clk)
		if(strobe == 1)
			if(((addr_str == 1 && vme_cycle == 1 && vme_read == 1) || we_byte[3] == 1) && addr[14:2] == ethernet_addr[14:2])
				start <= 1;
			else
				start <= 0;
	always@(posedge clk)
		if(strobe == 1 && addr_str == 1 && vme_cycle == 1)
			rd_eth <= vme_read;
	always@(posedge clk)
		if(strobe == 1)
			ethernet_dav <= start_dl && rd_eth;
	always@(posedge clk)
		if(strobe == 1)
			stop <= start_dl;
delayN #(.N(7))i_start_dl (.c(clk), .d(start), .ce(strobe), .q(start_dl));
	always@(posedge clk)
		if(strobe == 1)
			if(reset == 1)
				e_rdn <= 1;
			else if(addr_str == 1 && vme_cycle == 1 && vme_read == 1 && addr[14:2] == ethernet_addr[14:2])
				e_rdn <= 0;
			else if(stop == 1)
				e_rdn <= 1;
	always@(posedge clk)
		if(strobe == 1)
			if(we_byte[3] == 1)
				e_data_o <= w_data[7:0];
	always@(posedge clk)
		if(strobe == 1)
			if(reset == 1)
				t_e_data <= 1;
			else if(we_byte[3] == 1 && addr[14:2] == ethernet_addr[14:2])
				t_e_data <= 0;
			else if(stop == 1)
				t_e_data <= 1;
	always@(posedge clk)
		if(strobe == 1)
			if(reset == 1)
				e_wrn <= 1;
			else if(we_byte[3] == 1 && addr[14:2] == ethernet_addr[14:2])
				e_wrn <= 0;
			else if(stop == 1)
				e_wrn <= 1;
	always@(posedge clk)
		if(strobe == 1) begin
			clk_div <= clk_div + 1;
			if(clk_div == 3'h7)
				e_cycle <= 1;
			else
				e_cycle <= 0;
		end
	always@(posedge clk)
		if(strobe == 1)
			if(start_dl == 1 && rd_eth == 1)
				ethernet_data <= {~e_intn, 23'h0, e_data_i};
			else
				ethernet_data <= 32'h0;
endmodule
