`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:44:10 03/24/2009 
// Design Name: 
// Module Name:    ethernet 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
// this module uses TCP only, with one socket
//////////////////////////////////////////////////////////////////////////////////
module ethernetnew(
    input clk,
    input n_strobe,
		input reset,
		input addr_str,
    input [7:0] mod_sn, // module serial number, used as LSB of MAC and IP address
//		input vme_read,
//		input vme_cycle,
//    input [3:0] we_byte,
    input [31:0] r_data,
    input [15:0] addr,
    output reg e_csn = 1,
    output reg e_wrn = 1,
    output reg e_rdn = 1,
    output reg [1:0] e_addr,
//    inout [7:0] e_data,
    input [7:0] e_data,
    output reg [7:0] e_data_out,
		input en_write,
		input ethernet_sel,
		input ethernet_abort,
		input r_data_val,
    output reg [15:0] ethernet_addr,
    output reg [3:0] ethernet_rd_length,
    output reg [31:0] ethernet_wdata,
    output reg ethernet_read,
    output reg ethernet_str,
		output [31:0]debug
    );
parameter w_offset_l = 13+32;
parameter w_offset_h = 14+32;
parameter mask_DR = 15+32;
parameter r_base = 16+32;
parameter snd_data = 17+32;
parameter rcv_data = 18+32;
parameter clr_send = 19+32;
parameter cond = 27+32;
reg strobe = 0;
reg w5100_init = 1;
reg [2:0] et_str = 0;
wire et_str_dl;
	always@(posedge clk)
		strobe <= n_strobe;
	always@(posedge clk)
		if(strobe == 1)
			w5100_init <= w5100_init && ~addr_str;
	always@(posedge clk)
		if(strobe == 1)
			et_str[0] <= (w5100_init && addr_str) || et_str_dl;
	always@(posedge clk)
		if(strobe == 1)
			et_str[2:1] <= et_str[1:0];
	delayN #(.N(6))i_et_str_dlN (.c(clk), .d(et_str[2]), .ce(strobe), .q(et_str_dl)); //increase delay from 6 to 9 for 150MHz system clock
wire [63:0] sm;
wire [8:0] sm_aa;
wire [8:0] sm_ab;
reg choice = 0;
reg send_data = 0;
wire [3:0] s_e_data_out;
wire [7:0] SN;
wire we_send_data;
reg re_send_data = 0;
wire dav_send_datap;
reg dav_send_data;
wire [31:0] send_data_out;
reg [15:0] offset = 0;
reg [15:0] wc_read = 0;
reg [1:0] byte_cntr = 0;
reg [7:0] e_data_in = 0;
//reg [7:0] e_data_out = 0;
reg blk_end = 0;
reg aborted = 0;
//assign e_data = e_wrn ? 8'bZ : e_data_out;
assign we_send_data = r_data_val && ethernet_sel;
assign s_e_data_out = sm[snd_data] ? {aborted,1'b1,byte_cntr} : {aborted,1'b0, sm[29:28]};
srl_fifo #(.N(32))i_send_data (
    .rst(reset), 
    .din(r_data), 
		.w_strobe(strobe),
    .we(we_send_data), 
    .clk(clk), 
		.r_strobe(strobe),
    .re(re_send_data), 
    .dout(send_data_out),
		.dav(dav_send_datap),
    .rp()
    );
	always@(posedge clk)
		if(strobe == 1 && et_str_dl == 1)
			if(dav_send_data == 0)
				byte_cntr <= 0;
			else if(sm[snd_data] == 1)
				byte_cntr <= byte_cntr + 1;
	always@(posedge clk)
		if(strobe == 1)
			if(byte_cntr == 3 && sm[snd_data] == 1 && et_str[2] == 1)
				re_send_data <= 1;
			else
				re_send_data <= 0;
assign sm_aa = choice ? {sm[15:8],1'b0} : {sm[7:0],1'b0};
assign sm_ab = choice ? {sm[15:8],1'b1} : {sm[7:0],1'b1};
assign SN = mod_sn[7] ? mod_sn : {4'h7,mod_sn[3:0]};
reg [2:0] rec_size = 0;
reg ethernet_wr = 0;
reg ethernet_rd = 0;
reg branch = 0;
reg reading = 0;
reg rd_str = 0;
reg send_loop = 0;
reg start_send = 0;
reg offset_not_0 = 0;
reg rec_size_not_0 = 0;
reg got_buffer = 0;
reg last_blk = 0;

	always@(posedge clk)
		if(strobe == 1)
			if(aborted == 0)
				dav_send_data <= dav_send_datap;
			else if(rd_str == 1)
				dav_send_data <= 1;
			else if(re_send_data == 1 && blk_end == 1)
				dav_send_data <= 0;
	always@(posedge clk)
		if(strobe == 1)
			e_addr <= sm[33:32];
	always@(posedge clk)
		if(strobe == 1)begin
			if(et_str[0] == 1)begin
				e_wrn <= 1;
				e_rdn <= 1;
			end else if(et_str[1] == 1)begin
				e_wrn <= ~sm[34];
				e_rdn <= ~sm[35];
			end
		end
	always@(posedge clk)
		if(strobe == 1)
			if(et_str[2] == 1)
				e_csn <= ~sm[35] && ~sm[34];
			else if(et_str_dl == 1)
				e_csn <= 1;
	always@(posedge clk)
		if(strobe == 1)
			if(reading == 0)
				aborted <= 0;
			else if(ethernet_abort == 1)
				aborted <= 1;
	always@(posedge clk)
		if(strobe == 1)
			e_data_in <= e_data;
	always@(posedge clk)
		if(strobe == 1)
			if(sm[w_offset_h] == 1 && et_str_dl == 1)
				offset[15:8] <= {2'b1,sm[r_base],e_data_in[4:0]};
			else if(sm[w_offset_l] == 1 && et_str_dl == 1)
				offset[7:0] <= e_data_in;
			else if((sm[snd_data] == 1 || sm[rcv_data] == 1) && et_str[1] == 1)
				offset[12:0] <= offset[12:0]+1;
	always@(posedge clk)
		if(strobe == 1)
			if(sm[w_offset_h] == 1 && et_str[2] == 1 && sm[r_base] == 0)
				got_buffer <= 1;
			else if(sm[clr_send] == 1 && et_str[2] == 1)
				got_buffer <= 0;
	always@(posedge clk)
		if(strobe == 1 && et_str[1])
			case (s_e_data_out)
				4'h0: e_data_out <= sm[23:16];
				4'h1: e_data_out <= SN;
				4'h2: e_data_out <= offset[15:8];
				4'h3: e_data_out <= offset[7:0];
				4'h4: e_data_out <= send_data_out[31:24];
				4'h5: e_data_out <= send_data_out[23:16];
				4'h6: e_data_out <= send_data_out[15:8];
				4'h7: e_data_out <= send_data_out[7:0];
				4'h8: e_data_out <= sm[23:16];
				4'h9: e_data_out <= SN;
				4'ha: e_data_out <= offset[15:8];
				4'hb: e_data_out <= offset[7:0];
				default: e_data_out <= 8'hff;
			endcase
	always@(posedge clk)
		if(strobe == 1)
			if(sm[rcv_data] == 0) //
				rec_size <= 3'h7;
			else if(et_str[0] == 1)
				rec_size <= rec_size - 1;
	always@(posedge clk)
		if(strobe == 1)
			if(sm[rcv_data] == 1 && et_str_dl == 1) begin
				ethernet_addr <= {ethernet_addr[7:0],ethernet_wdata[31:24]};
				ethernet_wdata <= {ethernet_wdata[23:0],e_data_in};
				if(ethernet_addr == 16'ha000 && rec_size == 3'h1 && en_write == 1)
					ethernet_wr <= 1;
				else
					ethernet_wr <= 0;
				if(ethernet_addr == 16'h0500 && rec_size == 3'h1)
					ethernet_rd <= 1;
				else
					ethernet_rd <= 0;
				ethernet_read <= ethernet_rd;
			end else if(re_send_data == 1 && blk_end == 1)
				ethernet_addr[14:4] <= ethernet_addr[14:4] + 1;
	always@(posedge clk)
		if(strobe == 1)
			if(ethernet_rd == 1 && et_str[0] == 1)
				reading <= 1;
			else if(re_send_data == 1 && blk_end == 1 && wc_read[15:11] == ethernet_wdata[31:27] && last_blk == 1)
				reading <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(reading == 0)
				wc_read <= 0;
			else if(re_send_data == 1)
				wc_read <= wc_read + 1;
	always@(posedge clk)
		if(strobe == 1)
			if((last_blk == 1 && wc_read[3:0] == ethernet_wdata[19:16]) || wc_read[3:0] == 4'hf)
				blk_end <= 1;
			else
				blk_end <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if((sm[w_offset_h] == 1 && et_str[2] == 1 && sm[r_base] == 0) || (re_send_data == 1 && blk_end == 1 && last_blk == 0))
				rd_str <= 1;
			else
				rd_str <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(re_send_data == 1 && blk_end == 1 && last_blk == 1)
				start_send <= 1;
			else if(sm[clr_send] == 1 && et_str_dl == 1)
				start_send <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(wc_read[15:4] == ethernet_wdata[31:20] || wc_read[10:4] == 7'h7f)
				last_blk <= 1;
			else
				last_blk <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(wc_read[15:4] == ethernet_wdata[31:20])
				ethernet_rd_length <= ethernet_wdata[19:16];
			else
				ethernet_rd_length <= 4'hf;
	always@(posedge clk)
		if(strobe == 1)
			if(aborted == 0 && ((ethernet_wr == 1 && et_str_dl == 1) || rd_str == 1))
				ethernet_str <= 1;
			else
				ethernet_str <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(sm[cond] == 1 && ((e_data_in == sm[23:16] && sm[mask_DR] == 0) || (sm[mask_DR] == 1 && (e_data_in & sm[23:16]) == 0)))
				choice <= 1;
			else
				choice <= branch;
	always@(posedge clk)
		if(strobe == 1)
			if(offset[12:0] != 13'h0)
				offset_not_0 <= 1;
			else
				offset_not_0 <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(offset_not_0 == 1 && dav_send_data == 1)
				send_loop <= 1;
			else
				send_loop <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(rec_size == 3'h0)
				rec_size_not_0 <= 0;
			else
				rec_size_not_0 <= 1;
	always@(posedge clk)
		if(strobe == 1)
			case (sm[26:24])
				3'b001: branch <= rec_size_not_0;
				3'b010: branch <= dav_send_data;
				3'b011: branch <= send_loop;
				3'b100: branch <= ~start_send;
				3'b101: branch <= reading;
				3'b110: branch <= got_buffer;
				3'b111: branch <= offset_not_0;
				default: branch <= 0;
			endcase
reg en_sm = 0;
	always@(posedge clk)
		if(strobe == 1)
			en_sm <= 0;
		else
			en_sm <= et_str[0];
RAMB16_S36_S36
      #(.INIT_00(256'h00000005_00000004_00000004_00030003_08000008_00000201_00000004_00800001),
        .INIT_01(256'h00000007_00010008_00000007_00A80007_00000007_00C00006_00000006_00010005),
        .INIT_02(256'h00000007_00FF000C_00000007_00FF000B_00000007_00FF000A_00000007_00010009),
        .INIT_03(256'h00000007_00480010_00000007_00DE000F_00000007_00AC000E_00000007_0000000D),
        .INIT_04(256'h00000007_00C00014_00000007_00000013_00000007_10000012_00000007_00000011),
        .INIT_05(256'h00000006_00160018_00000007_10000017_00000007_00010016_00000007_00A80015),
        .INIT_06(256'h00000007_0008001C_00000007_00D0001B_00000007_0007001A_00000007_00000019),
        .INIT_07(256'h00000006_00000020_00000005_0004001F_00000007_0003001E_00000007_0003001D),
        .INIT_08(256'h00000007_00170024_00000007_00000023_00000006_00040022_00000007_00010021),
        .INIT_09(256'h0800000B_00002827_00000007_00010027_00000006_00010026_00000004_00010025),
        .INIT_0A(256'h00000007_0002002C_00000006_0001002B_0800000B_00132A5F_00000006_00030029),
        .INIT_0B(256'h0800000B_00173230_0800000B_0016312F_00000006_0003002E_0800000B_00002D2C),
        .INIT_0C(256'h00000006_00260034_00000004_00030033_0800000B_00173231_0800000B_0014315F),
        .INIT_0D(256'h0001400B_20000038_00000006_00280037_0800800B_00F84436_0800000B_00003536),
        .INIT_0E(256'h0004000B_01003B3C_00000006_3000003B_00000005_2000003A_0000200B_30000039),
        .INIT_0F(256'h00000007_30000040_00000007_2000003F_00000006_0028003E_00000005_0004003D),
        .INIT_10(256'h0800000B_00004442_00000006_00010043_00000007_00400042_00000006_00010041),
        .INIT_11(256'h0800800B_00F85A48_00000006_00200047_00000000_06004B46_00000000_0500455A),
        .INIT_12(256'h00000000_02004C5A_0000200B_3000004B_0000400B_2000004A_00000006_00240049),
        .INIT_13(256'h00000000_07005250_00020007_03004E4F_00000006_3000004E_00000005_2000004D),
        .INIT_14(256'h00000006_00240054_00000005_04045A53_00000006_02004E52_00000005_00400051),
        .INIT_15(256'h00080007_00200058_00000006_00010057_00000007_30000056_00000007_20000055),
        .INIT_16(256'h0800000B_001C5F5C_00000006_0003005B_0800000B_00005A58_00000006_00010059),
        .INIT_17(256'h00000006_00010060_00000000_05004432_0800000B_0000245E_00000006_0003005D),
        .INIT_18(256'h00000000_00000000_0800000B_00002461_00000006_00010062_00000007_00100061))
		i_state_machine(
      .DOA(sm[31:0]),      // Port A 32-bit Data Output
      .DOB(sm[63:32]),      // Port B 32-bit Data Output
      .DOPA(),    // Port A 4-bit Parity Output
      .DOPB(),    // Port B 4-bit Parity Output
      .ADDRA(sm_aa),  // Port A 9-bit Address Input
      .ADDRB(sm_ab),  // Port B 9-bit Address Input
      .CLKA(clk),    // Port A Clock
      .CLKB(clk),    // Port B Clock
      .DIA(32'b0),      // Port A 32-bit Data Input
      .DIB(32'b0),      // Port B 32-bit Data Input
      .DIPA(4'b0),    // Port A 4-bit parity Input
      .DIPB(4'b0),    // Port-B 4-bit parity Input
      .ENA(en_sm),      // Port A RAM Enable Input
      .ENB(en_sm),      // Port B RAM Enable Input
      .SSRA(w5100_init),    // Port A Synchronous Set/Reset Input
      .SSRB(w5100_init),    // Port B Synchronous Set/Reset Input
      .WEA(1'b0),      // Port A Write Enable Input
      .WEB(1'b0)       // Port B Write Enable Input
   );
reg [15:0] last_cmd = 0;
reg [7:0] wc_sent = 0;
reg [10:0] cmdbuf_a = 0;
wire [10:0] cmdbuf_aa;
wire we_cmdbuf;
wire rst_cmdbuf;
assign we_cmdbuf = sm[rcv_data] && et_str_dl;
assign rst_cmdbuf = (addr[14:10] == 5'h15) ? 0 : 1;
assign cmdbuf_aa = {cmdbuf_a[10:2],~cmdbuf_a[1:0]};
RAMB16_S9_S36
   i_cmdbuf (
      .DOA(),   // Port A 8-bit Data Output
      .DOB(debug),   // Port B 32-bit Data Output
      .DOPA(), // Port A 1-bit Parity Output
      .DOPB(), // Port B 4-bit Parity Output
      .ADDRA(cmdbuf_aa),  // Port A 11-bit Address Input
      .ADDRB(addr[8:0]),  // Port B 9-bit Address Input
      .CLKA(clk),    // Port A Clock
      .CLKB(clk),    // Port B Clock
      .DIA(e_data_in),      // Port A 8-bit Data Input
      .DIB(32'b0),      // Port B 32-bit Data Input
      .DIPA(1'b0),    // Port A 1-bit parity Input
      .DIPB(4'b0),    // Port-B 4-bit parity Input
      .ENA(strobe),      // Port A RAM Enable Input
      .ENB(strobe),      // Port B RAM Enable Input
      .SSRA(1'b0),    // Port A Synchronous Set/Reset Input
      .SSRB(rst_cmdbuf),    // Port B Synchronous Set/Reset Input
      .WEA(we_cmdbuf),      // Port A Write Enable Input
      .WEB(1'b0)       // Port B Write Enable Input
   );
	always@(posedge clk)
		if(strobe == 1)
			if(reset == 1)
				cmdbuf_a <= 11'h0;
			else if(sm[rcv_data] == 1 && et_str_dl == 1 && cmdbuf_a[10] == 0)
				cmdbuf_a <= cmdbuf_a + 1;
//	always@(posedge clk)
//		if(strobe == 1)
//			if(reset == 1)
//				wc_sent <= 8'h0;
////			else if(re_send_data == 1)
//			else if(sm[rcv_data] == 1 && et_str_dl == 1)
//				wc_sent <= wc_sent + 1;
//	always@(posedge clk)
//		if(strobe == 1)
//			if(sm[rcv_data] == 1 && et_str_dl == 1)
//				last_cmd <={last_cmd[7:0],ethernet_addr[15:8]};
//	always@(posedge clk)
//		if(strobe == 1)
//			if(addr[14:10] == 5'h15)begin
//				debug[31:24] <= wc_sent;
//				debug[23:16] <= {reading,sm_aa[7:1]};
//				debug[15:0] <= last_cmd;
//			end else
//				debug <= 32'h0;
endmodule
