`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:44:10 03/24/2009 
// Design Name: 
// Module Name:    ethernet 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
// this module uses TCP only, with one socket
//////////////////////////////////////////////////////////////////////////////////
module ethernetnew(
    input clk,
    input n_strobe,
		input reset,
		input addr_str,
    input [7:0] mod_sn, // module serial number, used as LSB of MAC and IP address
//		input vme_read,
//		input vme_cycle,
//    input [3:0] we_byte,
    input [31:0] r_data,
//    input [15:0] addr,
    output reg e_csn = 1,
    output reg e_wrn = 1,
    output reg e_rdn = 1,
    output reg [1:0] e_addr,
    inout [7:0] e_data,
		input ethernet_sel,
		input ethernet_abort,
		input r_data_val,
    output reg [15:0] ethernet_addr,
    output reg [3:0] ethernet_rd_length,
    output reg [31:0] ethernet_wdata,
    output reg ethernet_read,
    output reg ethernet_str,
		output [31:0]debug
    );
parameter w_offset_l = 13+32;
parameter w_offset_h = 14+32;
parameter mask_DR = 15+32;
parameter r_base = 16+32;
parameter snd_data = 17+32;
parameter rcv_data = 18+32;
parameter clr_send = 19+32;
parameter cond = 27+32;
reg strobe = 0;
reg w5100_init = 1;
reg [2:0] et_str = 0;
wire et_str_dl;
	always@(posedge clk)
		strobe <= n_strobe;
	always@(posedge clk)
		if(strobe == 1)
			w5100_init <= w5100_init && ~addr_str;
	always@(posedge clk)
		if(strobe == 1)
			et_str[0] <= (w5100_init && addr_str) || et_str_dl;
	always@(posedge clk)
		if(strobe == 1)
			et_str[2:1] <= et_str[1:0];
	delayN #(.N(6))i_et_str_dlN (.c(clk), .d(et_str[2]), .ce(strobe), .q(et_str_dl)); //increase delay from 6 to 9 for 150MHz system clock
wire [63:0] sm;
wire [8:0] sm_aa;
wire [8:0] sm_ab;
reg choice = 0;
reg send_data = 0;
wire [2:0] s_e_data_out;
wire [7:0] SN;
wire we_send_data;
reg re_send_data = 0;
wire dav_send_data;
wire [31:0] send_data_out;
reg [15:0] offset = 0;
reg [11:0] blk_read = 0;
reg [1:0] byte_cntr = 0;
reg [7:0] e_data_in = 0;
reg [7:0] e_data_out = 0;
assign e_data = e_wrn ? 8'bZ : e_data_out;
assign we_send_data = r_data_val && ethernet_sel;
assign s_e_data_out = sm[snd_data] ? {1'b1,byte_cntr} : {1'b0, sm[29:28]};
srl_fifo #(.N(32))i_send_data (
    .rst(reset), 
    .din(r_data), 
		.w_strobe(strobe),
    .we(we_send_data), 
    .clk(clk), 
		.r_strobe(strobe),
    .re(re_send_data), 
    .dout(send_data_out),
		.dav(dav_send_data),
    .rp()
    );
	always@(posedge clk)
		if(strobe == 1 && et_str_dl == 1)
			if(dav_send_data == 0)
				byte_cntr <= 0;
			else if(sm[snd_data] == 1)
				byte_cntr <= byte_cntr + 1;
	always@(posedge clk)
		if(strobe == 1)
			if(byte_cntr == 3 && sm[snd_data] == 1 && et_str[1] == 1)
				re_send_data <= 1;
			else
				re_send_data <= 0;
assign sm_aa = choice ? {sm[15:8],1'b0} : {sm[7:0],1'b0};
assign sm_ab = choice ? {sm[15:8],1'b1} : {sm[7:0],1'b1};
assign SN = mod_sn[7] ? mod_sn : {4'h7,mod_sn[3:0]};
reg [2:0] rec_size = 0;
reg ethernet_wr = 0;
reg ethernet_rd = 0;
reg branch = 0;
reg reading = 0;
reg rd_str = 0;
reg send_loop = 0;
reg start_send = 0;
reg offset_not_0 = 0;
reg rec_size_not_0 = 0;
reg chk_send = 0;
reg got_buffer = 0;
reg last_blk = 0;
reg aborted = 0;

	always@(posedge clk)
		if(strobe == 1)
			e_addr <= sm[33:32];
	always@(posedge clk)
		if(strobe == 1)begin
			if(et_str[0] == 1)begin
				e_wrn <= 1;
				e_rdn <= 1;
			end else if(et_str[1] == 1)begin
				e_wrn <= ~sm[34];
				e_rdn <= ~sm[35];
			end
		end
	always@(posedge clk)
		if(strobe == 1)
			if(et_str[2] == 1)
				e_csn <= ~sm[35] && ~sm[34];
			else if(et_str_dl == 1)
				e_csn <= 1;
	always@(posedge clk)
		if(strobe == 1)
			if(reading == 0)
				aborted <= 0;
			else if(ethernet_abort == 1)
				aborted <= 1;
	always@(posedge clk)
		if(strobe == 1)
			e_data_in <= e_data;
	always@(posedge clk)
		if(strobe == 1)
			if(sm[w_offset_h] == 1 && et_str_dl == 1)
				offset[15:8] <= {2'b1,sm[r_base],e_data_in[4:0]};
			else if(sm[w_offset_l] == 1 && et_str_dl == 1)
				offset[7:0] <= e_data_in;
			else if((sm[snd_data] == 1 || sm[rcv_data] == 1) && et_str[1] == 1)
				offset[12:0] <= offset[12:0]+1;
	always@(posedge clk)
		if(strobe == 1)
			if(sm[w_offset_h] == 1 && et_str[2] == 1 && sm[r_base] == 0)
				got_buffer <= 1;
			else if(sm[clr_send] == 1 && et_str[2] == 1)
				got_buffer <= 0;
	always@(posedge clk)
		if(strobe == 1 && et_str[1])
			case (s_e_data_out)
				3'b001: e_data_out <= SN;
				3'b010: e_data_out <= offset[15:8];
				3'b011: e_data_out <= offset[7:0];
				3'b100: e_data_out <= send_data_out[31:24];
				3'b101: e_data_out <= send_data_out[23:16];
				3'b110: e_data_out <= send_data_out[15:8];
				3'b111: e_data_out <= send_data_out[7:0];
				default: e_data_out <= sm[23:16];
			endcase
	always@(posedge clk)
		if(strobe == 1)
			if(sm[rcv_data] == 0) //
				rec_size <= 3'h7;
			else if(et_str[0] == 1)
				rec_size <= rec_size - 1;
	always@(posedge clk)
		if(strobe == 1)
			if(sm[rcv_data] == 1 && et_str_dl == 1) begin
				ethernet_addr <= {ethernet_addr[7:0],ethernet_wdata[31:24]};
				ethernet_wdata <= {ethernet_wdata[23:0],e_data_in};
				if(ethernet_addr == 16'ha000 && rec_size == 3'h1)
					ethernet_wr <= 1;
				else
					ethernet_wr <= 0;
				if(ethernet_addr == 16'h0500 && rec_size == 3'h1)
					ethernet_rd <= 1;
				else
					ethernet_rd <= 0;
				ethernet_read <= ethernet_rd;
			end else if(chk_send == 1 && dav_send_data == 0)
				ethernet_addr[14:4] <= ethernet_addr[14:4] + 1;
	always@(posedge clk)
		if(strobe == 1)
			if(ethernet_rd == 1 && et_str[0] == 1)
				reading <= 1;
			else if(chk_send == 1 && dav_send_data == 0 && blk_read[11:7] == ethernet_wdata[31:27] && last_blk == 1)
				reading <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(reading == 0)
				blk_read <= 0;
			else if(chk_send == 1 && dav_send_data == 0)
				blk_read <= blk_read + 1;
	always@(posedge clk)
		if(strobe == 1)
			chk_send <=	re_send_data;
	always@(posedge clk)
		if(strobe == 1)
			if((sm[w_offset_h] == 1 && et_str[2] == 1 && sm[r_base] == 0) || (chk_send == 1 && dav_send_data == 0 && last_blk == 0))
				rd_str <= 1;
			else
				rd_str <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(chk_send == 1 && dav_send_data == 0 && last_blk == 1)
				start_send <= 1;
			else if(sm[clr_send] == 1 && et_str_dl == 1)
				start_send <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(blk_read == ethernet_wdata[31:20] || blk_read[6:0] == 7'h7f)
				last_blk <= 1;
			else
				last_blk <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(blk_read == ethernet_wdata[31:20])
				ethernet_rd_length <= ethernet_wdata[19:16];
			else
				ethernet_rd_length <= 4'hf;
	always@(posedge clk)
		if(strobe == 1)
			if(aborted == 0 && ((ethernet_wr == 1 && et_str_dl == 1) || rd_str == 1))
				ethernet_str <= 1;
			else
				ethernet_str <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(sm[cond] == 1 && ((e_data_in == sm[23:16] && sm[mask_DR] == 0) || (sm[mask_DR] == 1 && (e_data_in & sm[23:16]) == 0)))
				choice <= 1;
			else
				choice <= branch;
	always@(posedge clk)
		if(strobe == 1)
			if(offset[12:0] != 13'h0)
				offset_not_0 <= 1;
			else
				offset_not_0 <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(offset_not_0 == 1 && dav_send_data == 1)
				send_loop <= 1;
			else
				send_loop <= 0;
	always@(posedge clk)
		if(strobe == 1)
			if(rec_size == 3'h0)
				rec_size_not_0 <= 0;
			else
				rec_size_not_0 <= 1;
	always@(posedge clk)
		if(strobe == 1)
			case (sm[26:24])
				3'b001: branch <= rec_size_not_0;
				3'b010: branch <= dav_send_data;
				3'b011: branch <= send_loop;
				3'b100: branch <= ~start_send;
				3'b101: branch <= reading;
				3'b110: branch <= got_buffer;
				3'b111: branch <= offset_not_0;
				default: branch <= 0;
			endcase
reg en_sm = 0;
	always@(posedge clk)
		if(strobe == 1)
			en_sm <= 0;
		else
			en_sm <= et_str[0];
RAMB16_S36_S36
      #(.INIT_00(256'h00000005_00000004_00000004_00030003_08000008_00000201_00000004_00800001),
        .INIT_01(256'h00000007_00010008_00000007_00A80007_00000007_00C00006_00000006_00010005),
        .INIT_02(256'h00000007_00FF000C_00000007_00FF000B_00000007_00FF000A_00000007_00010009),
        .INIT_03(256'h00000007_00480010_00000007_00DE000F_00000007_00AC000E_00000007_0000000D),
        .INIT_04(256'h00000007_00C00014_00000007_00000013_00000007_10000012_00000007_00000011),
        .INIT_05(256'h00000006_00160018_00000007_10000017_00000007_00010016_00000007_00A80015),
        .INIT_06(256'h00000007_0008001C_00000007_00D0001B_00000007_0007001A_00000007_00000019),
        .INIT_07(256'h00000006_00000020_00000005_0004001F_00000007_0003001E_00000007_0003001D),
        .INIT_08(256'h00000007_00170024_00000007_00000023_00000006_00040022_00000007_00010021),
        .INIT_09(256'h0800000B_00002827_00000007_00010027_00000006_00010026_00000004_00010025),
        .INIT_0A(256'h00000007_0002002C_00000006_0001002B_0800000B_00132A5E_00000006_00030029),
        .INIT_0B(256'h0800000B_00173230_0800000B_0016312F_00000006_0003002E_0800000B_00002D2C),
        .INIT_0C(256'h00000006_00260034_00000004_00030033_0800000B_00173231_0800000B_0014315E),
        .INIT_0D(256'h0000200B_30000038_0001400B_20000037_0800800B_00F84336_0800000B_00003536),
        .INIT_0E(256'h00000005_0004003C_0004000B_01003A3B_00000006_3000003A_00000005_20000039),
        .INIT_0F(256'h00000006_00010040_00000007_3000003F_00000007_2000003E_00000006_0028003D),
        .INIT_10(256'h00000000_05004459_0800000B_00004341_00000006_00010042_00000007_00400041),
        .INIT_11(256'h00000006_00240048_0800800B_00F85947_00000006_00200046_00000000_06004A45),
        .INIT_12(256'h00000005_2000004C_00000000_02004B59_0000200B_3000004A_0000400B_20000049),
        .INIT_13(256'h00000005_00400050_00000000_0700514F_00020007_03004D4E_00000006_3000004D),
        .INIT_14(256'h00000007_20000054_00000006_00240053_00000005_04045952_00000006_02004D51),
        .INIT_15(256'h00000006_00010058_00080007_00200057_00000006_00010056_00000007_30000055),
        .INIT_16(256'h00000006_0003005C_0800000B_001C5E5B_00000006_0003005A_0800000B_00005957),
        .INIT_17(256'h00000007_00100060_00000006_0001005F_00000000_05004332_0800000B_0000245D),
        .INIT_18(256'h00000000_00000000_00000000_00000000_0800000B_00002460_00000006_00010061))
		i_state_machine(
      .DOA(sm[31:0]),      // Port A 32-bit Data Output
      .DOB(sm[63:32]),      // Port B 32-bit Data Output
      .DOPA(),    // Port A 4-bit Parity Output
      .DOPB(),    // Port B 4-bit Parity Output
      .ADDRA(sm_aa),  // Port A 9-bit Address Input
      .ADDRB(sm_ab),  // Port B 9-bit Address Input
      .CLKA(clk),    // Port A Clock
      .CLKB(clk),    // Port B Clock
      .DIA(32'b0),      // Port A 32-bit Data Input
      .DIB(32'b0),      // Port B 32-bit Data Input
      .DIPA(4'b0),    // Port A 4-bit parity Input
      .DIPB(4'b0),    // Port-B 4-bit parity Input
      .ENA(en_sm),      // Port A RAM Enable Input
      .ENB(en_sm),      // Port B RAM Enable Input
      .SSRA(w5100_init),    // Port A Synchronous Set/Reset Input
      .SSRB(w5100_init),    // Port B Synchronous Set/Reset Input
      .WEA(1'b0),      // Port A Write Enable Input
      .WEB(1'b0)       // Port B Write Enable Input
   );
endmodule
