----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    07:26:36 02/17/2009 
-- Design Name: 
-- Module Name:    lfsr2mem - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity lfsr2mem is
    Port ( clk : in  STD_LOGIC;
           lfsr_data : in  STD_LOGIC_VECTOR (32 downto 0);
					 reset : in STD_LOGIC;
					 lfsr_dav : in STD_LOGIC;
					 mon_re : in STD_LOGIC;
					 htr_buf_afull : out STD_LOGIC;
					 mon_we : out STD_LOGIC;
					 mon_avl : out STD_LOGIC;
           test_wc : out  STD_LOGIC_VECTOR (31 downto 0);
           mon_data : out  STD_LOGIC_VECTOR (32 downto 0));
end lfsr2mem;

architecture Behavioral of lfsr2mem is
signal fifo_din: std_logic_vector(35 downto 0) := (others => '0');
signal fifo_dout: std_logic_vector(35 downto 0) := (others => '0');
signal fifo_wa: std_logic_vector(8 downto 0) := (others => '0');
signal fifo_ra: std_logic_vector(31 downto 0) := (others => '0');
signal ec_fifo_ra : std_logic := '0';
begin
fifo_din <= "000" & lfsr_data;
mon_data(31 downto 0) <= fifo_dout(31 downto 0);
test_wc <= fifo_ra;
-- monitor event fifo
mon_fifo: RAMB16_S36_S36
	  generic map(SIM_COLLISION_CHECK => "NONE")
  port map(DIA => fifo_din(31 downto 0),
  			  DIPA => fifo_din(35 downto 32),
  			  DIB => x"00000000",
  			  DIPB => x"0",
  			  ENA => '1',
  			  ENB => '1',
  			  WEA => lfsr_dav,
  			  WEB => '0',
  			  SSRA => '0',
  			  SSRB => '0',
					CLKA => clk,
					CLKB => clk,
					ADDRA => fifo_wa,
					ADDRB => fifo_ra(8 downto 0),
					DOB => fifo_dout(31 downto 0),
					DOPB => fifo_dout(35 downto 32)
					);
---------------------------------		
process(clk)
begin
  if(clk'event and clk = '1')then
    if(reset = '1')then
			fifo_wa <= (others => '0');
			fifo_ra <= (others => '0');
		else
			if(lfsr_dav = '1')then
				fifo_wa <= fifo_wa + 1;
			end if; 
			if(ec_fifo_ra = '1')then
		    fifo_ra <= fifo_ra + 1;
			end if;
    end if;
    if(reset = '1')then
			mon_avl <= '0';
      ec_fifo_ra <= '0';
			mon_we <= '0';
    else
      if(ec_fifo_ra = '1' or fifo_wa(8 downto 6) = fifo_ra(8 downto 6))then
        mon_avl <= '0';
			else
        mon_avl <= '1';
      end if;
      if(mon_re = '1')then
        ec_fifo_ra <= '1';
      elsif(fifo_ra(5 downto 0) = "111111")then
        ec_fifo_ra <= '0';
      end if;
			mon_we <= ec_fifo_ra;
    end if;
		mon_data(32) <= and_reduce(fifo_ra(12 downto 0));
  end if;
end process;
end Behavioral;

