----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:19:22 02/12/2009 
-- Design Name: 
-- Module Name:    lrb_blk - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity lrb_blk is
		generic (sim : boolean := true);
    Port ( clk_p : in  STD_LOGIC; -- system clock in
           clk_n : in  STD_LOGIC; -- system clock in
           lrbA_in_p : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbA_in_n : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbB_in_p : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbB_in_n : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbC_in_p : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbC_in_n : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
-- spare inputs
           CCLK : in  STD_LOGIC; -- system clock in
           CDATA : in  STD_LOGIC; -- system clock in
-- chip ID
           chip_ID : in  STD_LOGIC_VECTOR (2 downto 0);
-- input data
           RXD_p : in  STD_LOGIC;
           RXD_n : in  STD_LOGIC;
-- LED driver
           LED : out  STD_LOGIC_VECTOR (4 downto 0);
-- output data
           TXD_p : out  STD_LOGIC_VECTOR (8 downto 0);
           TXD_n : out  STD_LOGIC_VECTOR (8 downto 0);
-- output clock
           TXclk_p : out  STD_LOGIC;
           TXclk_n : out  STD_LOGIC);
end lrb_blk;

architecture Behavioral of lrb_blk is
component LRB
		generic (sim : boolean := true);
    Port ( clk_p : in  STD_LOGIC; -- system clock in
           clk_n : in  STD_LOGIC; -- system clock in
           lrbA_in_p : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbA_in_n : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbB_in_p : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbB_in_n : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbC_in_p : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
           lrbC_in_n : in  STD_LOGIC_VECTOR (4 downto 0); -- link in
-- spare inputs
           CCLK : in  STD_LOGIC; -- system clock in
           CDATA : in  STD_LOGIC; -- system clock in
-- chip ID
           chip_ID : in  STD_LOGIC_VECTOR (2 downto 0);
-- input data
           RXD_p : in  STD_LOGIC;
           RXD_n : in  STD_LOGIC;
-- LED driver
           LED : out  STD_LOGIC_VECTOR (4 downto 0);
-- output data
           TXD_p : out  STD_LOGIC_VECTOR (8 downto 0);
           TXD_n : out  STD_LOGIC_VECTOR (8 downto 0);
-- output clock
           TXclk_p : out  STD_LOGIC;
           TXclk_n : out  STD_LOGIC;
-- DDR pins
           MDQ : inout  STD_LOGIC_VECTOR (15 downto 0);
           MA : out  STD_LOGIC_VECTOR (12 downto 0);
           MBA : out  STD_LOGIC_VECTOR (1 downto 0);
           DM : out  STD_LOGIC_VECTOR (1 downto 0);
           DQS : inout  STD_LOGIC_VECTOR (1 downto 0);
           WE_n : out  STD_LOGIC;
           CAS_n : out  STD_LOGIC;
           RAS_n : out  STD_LOGIC;
           CS_n : out  STD_LOGIC;
           mclke : out  STD_LOGIC;
           mclk : out  STD_LOGIC;
           mclk_n : out  STD_LOGIC
		);
END COMPONENT;
component ddr
  port(
      Clk: in std_logic;
      Clk_n: in std_logic;
      Cke: in std_logic;
      Cs_n: in std_logic;
      Ras_n: in std_logic;
      Cas_n: in std_logic;
      We_n: in std_logic;
      Ba: in std_logic_vector(1 downto 0);
      Addr: in std_logic_vector(12 downto 0);
      Dm: in std_logic_vector(1 downto 0);
      Dq: in std_logic_vector(15 downto 0);
      Dq_o: out std_logic_vector(15 downto 0);
      T_dq: out std_logic;
      Dqs: in std_logic_vector(1 downto 0);
      Dqs_o: out std_logic_vector(1 downto 0);
      T_dqs: out std_logic
  );
end component;
	--BiDirs
   signal mdq : std_logic_vector(15 downto 0);
	SIGNAL dq_o :  std_logic_vector(15 downto 0);
	SIGNAL T_dq :  std_logic;
	SIGNAL dqs :  std_logic_vector(1 downto 0);
	SIGNAL dqs_o :  std_logic_vector(1 downto 0);
	SIGNAL T_dqs :  std_logic;

 	--Outputs
   signal MA : std_logic_vector(12 downto 0);
   signal MBA : std_logic_vector(1 downto 0);
   signal DM : std_logic_vector(1 downto 0);
   signal WE_n : std_logic;
   signal CAS_n : std_logic;
   signal RAS_n : std_logic;
   signal CS_n : std_logic;
   signal mclke : std_logic;
   signal mclk : std_logic;
   signal mclk_n : std_logic;
   signal mdqp : std_logic_vector(15 downto 0);
	 SIGNAL dqsp :  std_logic_vector(1 downto 0);

begin
	mdqp <= "LLLLLLLLLLLLLLLL" when T_dq = '1' else dq_o;
	dqsp <= "HH" when T_dqs = '1' else dqs_o;
mdq <= mdqp after 1ns;
dqs <= dqsp after 2.6ns;
i_ddr: ddr port map(
      Clk => mclk,
      Clk_n => mclk_n,
      Cke => mclke,
		Dq => mdq,
		Dq_o => dq_o,
		T_dq => T_dq,
		Addr => ma,
		Ba => mba,
		Dm => dm,
		Dqs => dqs,
		Dqs_o => dqs_o,
		T_dqs => T_dqs,
		We_n => we_n,
		Ras_n => ras_n,
		Cas_n => cas_n,
		Cs_n => cs_n
			);
   ut: LRB generic map(sim => sim) PORT MAP (
          clk_p => clk_p,
          clk_n => clk_n,
          lrbA_in_p => lrbA_in_p,
          lrbA_in_n => lrbA_in_n,
          lrbB_in_p => lrbB_in_p,
          lrbB_in_n => lrbB_in_n,
          lrbC_in_p => lrbC_in_p,
          lrbC_in_n => lrbC_in_n,
          CCLK => CCLK,
          CDATA => CDATA,
          chip_ID => chip_ID,
          RXD_p => RxD_p,
          RXD_n => RxD_n,
          LED => LED,
          TXD_p => TxD_p,
          TXD_n => TxD_n,
          TXclk_p => Txclk_p,
          TXclk_n => Txclk_n,
          MDQ => MDQ,
          MA => MA,
          MBA => MBA,
          DM => DM,
          DQS => DQS,
          WE_n => WE_n,
          CAS_n => CAS_n,
          RAS_n => RAS_n,
          CS_n => CS_n,
          mclke => mclke,
          mclk => mclk,
          mclk_n => mclk_n
        );


end Behavioral;

