--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   11:45:56 04/27/2009
-- Design Name:   
-- Module Name:   C:/iseproj/VME_dcc/DSP_dummy/slink_tb.vhd
-- Project Name:  DSP_dummy
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: slink
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY slink_tb IS
END slink_tb;
 
ARCHITECTURE behavior OF slink_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT slink
    PORT(
         clk : IN  std_logic;
         reset : IN  std_logic;
         n_strobe : IN  std_logic;
         addr : IN  std_logic_vector(15 downto 0);
         we_byte : IN  std_logic_vector(3 downto 0);
         w_data : IN  std_logic_vector(31 downto 0);
         slink_buf : OUT  std_logic_vector(31 downto 0);
         slink_pntr : OUT  std_logic_vector(31 downto 0);
         en_slink : IN  std_logic;
         slink64 : IN  std_logic;
         slink_ctrl : IN  std_logic;
         slink_din : IN  std_logic_vector(35 downto 0);
         slink_we : IN  std_logic;
         slink_send : OUT  std_logic;
         slink_full : OUT  std_logic;
         slink_down : OUT  std_logic;
         inc_slink_wc : OUT  std_logic;
         inc_slink_bc : OUT  std_logic;
         inc_crc_err : OUT  std_logic;
         slink_test : IN  std_logic;
         LDOWNn : IN  std_logic;
         LFFn : IN  std_logic;
         LRL : IN  std_logic_vector(3 downto 0);
         LSF : IN  std_logic_vector(3 downto 0);
         UCLK : OUT  std_logic;
         UTESTn : OUT  std_logic;
         UWENn : OUT  std_logic;
         URESETn : OUT  std_logic;
         UCTRLn : OUT  std_logic;
         UDW : OUT  std_logic_vector(1 downto 0);
         UD : OUT  std_logic_vector(63 downto 0);
         USF : OUT  std_logic_vector(3 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal reset : std_logic := '1';
   signal n_strobe : std_logic := '0';
   signal addr : std_logic_vector(15 downto 0) := (others => '0');
   signal we_byte : std_logic_vector(3 downto 0) := (others => '0');
   signal w_data : std_logic_vector(31 downto 0) := (others => '0');
   signal en_slink : std_logic := '1';
   signal slink64 : std_logic := '1';
   signal slink_ctrl : std_logic := '0';
   signal slink_din : std_logic_vector(35 downto 0) := (others => '0');
   signal slink_we : std_logic := '0';
   signal slink_test : std_logic := '0';
   signal LDOWNn : std_logic := '1';
   signal LFFn : std_logic := '1';
   signal LRL : std_logic_vector(3 downto 0) := (others => '0');
   signal LSF : std_logic_vector(3 downto 0) := (others => '0');

 	--Outputs
   signal slink_buf : std_logic_vector(31 downto 0);
   signal slink_pntr : std_logic_vector(31 downto 0);
   signal slink_send : std_logic;
   signal slink_full : std_logic;
   signal slink_down : std_logic;
   signal inc_slink_wc : std_logic;
   signal inc_slink_bc : std_logic;
   signal inc_crc_err : std_logic;
   signal UCLK : std_logic;
   signal UTESTn : std_logic;
   signal UWENn : std_logic;
   signal URESETn : std_logic;
   signal UCTRLn : std_logic;
   signal UDW : std_logic_vector(1 downto 0);
   signal UD : std_logic_vector(63 downto 0);
   signal USF : std_logic_vector(3 downto 0);

   signal cntr : std_logic_vector(31 downto 0) := (others => '0');

   -- Clock period definitions
   constant clk_period : time := 10ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: slink PORT MAP (
          clk => clk,
          reset => reset,
          n_strobe => n_strobe,
          addr => addr,
          we_byte => we_byte,
          w_data => w_data,
          slink_buf => slink_buf,
          slink_pntr => slink_pntr,
          en_slink => en_slink,
          slink64 => slink64,
          slink_ctrl => slink_ctrl,
          slink_din => slink_din,
          slink_we => slink_we,
          slink_send => slink_send,
          slink_full => slink_full,
          slink_down => slink_down,
          inc_slink_wc => inc_slink_wc,
          inc_slink_bc => inc_slink_bc,
          inc_crc_err => inc_crc_err,
          slink_test => slink_test,
          LDOWNn => LDOWNn,
          LFFn => LFFn,
          LRL => LRL,
          LSF => LSF,
          UCLK => UCLK,
          UTESTn => UTESTn,
          UWENn => UWENn,
          URESETn => URESETn,
          UCTRLn => UCTRLn,
          UDW => UDW,
          UD => UD,
          USF => USF
        );
slink_din <= x"0" & cntr(15 downto 0) & cntr(15 downto 0);
   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
process(clk)
begin 
  if(clk'event and clk = '1')then
		n_strobe <= not n_strobe;
		cntr <= cntr + 1;
    if(cntr = x"00000010")then
			slink_we <= '1';
		elsif(cntr = x"00000030")then
			slink_we <= '0';
		end if;
    if(cntr < x"00000014" or cntr > x"0000002d")then
			slink_ctrl <= '1';
		else
			slink_ctrl <= '0';
		end if;
  end if;
end process;

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for clk_period*10;
reset <= '0';
      -- insert stimulus here 

      wait;
   end process;

END;
