--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   07:38:08 03/03/2009
-- Design Name:   
-- Module Name:   C:/iseproj/VME_dcc/LRB/srl_fifo32_tb.vhd
-- Project Name:  LRB
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: srl_fifo32
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY srl_fifo32_tb IS
END srl_fifo32_tb;
 
ARCHITECTURE behavior OF srl_fifo32_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT srl_fifo32
    PORT(
         rst : IN  std_logic;
         din : IN  std_logic_vector(31 downto 0);
         w_strobe : IN  std_logic;
         we : IN  std_logic;
         clk : IN  std_logic;
         r_strobe : IN  std_logic;
         re : IN  std_logic;
         dav : OUT  std_logic;
         dout : OUT  std_logic_vector(31 downto 0);
         rp : OUT  std_logic_vector(4 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal rst : std_logic := '1';
   signal din : std_logic_vector(31 downto 0) := (others => '0');
   signal w_strobe : std_logic := '0';
   signal we : std_logic := '0';
   signal clk : std_logic := '0';
   signal r_strobe : std_logic := '1';
   signal re : std_logic := '0';

 	--Outputs
   signal dav : std_logic;
   signal dout : std_logic_vector(31 downto 0);
   signal rp : std_logic_vector(4 downto 0);

   -- Clock period definitions
   constant clk_period : time := 10ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: srl_fifo32 PORT MAP (
          rst => rst,
          din => din,
          w_strobe => w_strobe,
          we => we,
          clk => clk,
          r_strobe => r_strobe,
          re => re,
          dav => dav,
          dout => dout,
          rp => rp
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
process(clk)
begin
	if(clk'event and clk = '1')then
		din <= din + 1;
		we <= not we and not rst;
		if(w_strobe = '1')then
			rst <= '0';
		end if;
		if(r_strobe = '1' and din(6) = '1')then
			re <= '1';
		end if;
		w_strobe <= not w_strobe;
	end if;
end process; 
r_strobe <= w_strobe;
   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for 100ms;	

      wait for clk_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
