----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    07:08:12 12/31/2008 
-- Design Name: 
-- Module Name:    vme_link - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_misc.all;
use mylib.dcc_pack.all;
library UNISIM;
use UNISIM.VComponents.all;

entity vme_link is
		generic (sim : boolean := false);
    Port ( clk : in  STD_LOGIC;
           clk180 : in  STD_LOGIC;
           clk_lock : in  STD_LOGIC;
           n_strobe : out  STD_LOGIC;
           vmeclk : in  STD_LOGIC;
           TXD_p : in  STD_LOGIC_VECTOR (4 downto 0);
           TXD_n : in  STD_LOGIC_VECTOR (4 downto 0);
           RXCLK_P : out  STD_LOGIC;
           RXCLK_n : out  STD_LOGIC;
           RXD_P : out  STD_LOGIC_VECTOR (4 downto 0);
           RXD_n : out  STD_LOGIC_VECTOR (4 downto 0);
           addr_str : out  STD_LOGIC;
           vme_cycle : out  STD_LOGIC;
           vme_read : out  STD_LOGIC;
					 inc_addr: in STD_LOGIC;
           mem_test : out  STD_LOGIC;
					 LRB_ack: in STD_LOGIC_VECTOR (4 downto 0);
					 r_data_val: in STD_LOGIC;
           addr : out  STD_LOGIC_VECTOR (15 downto 0);
           rd_length : out  STD_LOGIC_VECTOR (3 downto 0);
           r_data : in  STD_LOGIC_VECTOR (31 downto 0);
					 we_byte : out std_logic_vector(3 downto 0);
           w_data : out  STD_LOGIC_VECTOR (31 downto 0));
end vme_link;

architecture Behavioral of vme_link is
signal strobe: std_logic := '0';
signal vme_cycle_i: std_logic := '0';
signal mem_test_i: std_logic := '0';
signal RXclk: std_logic := '0';
signal TXD: std_logic_vector(4 downto 0) := (others => '0');
signal TXD_q: std_logic_vector(4 downto 0) := (others => '0');
signal RXD: std_logic_vector(4 downto 0) := (others => '0');
signal tx_datap: std_logic_vector(9 downto 0) := (others => '0');
signal tx_data: std_logic_vector(9 downto 0) := (others => '0');
signal rx_data: std_logic_vector(9 downto 0) := (others => '0');
signal we_rxbuf : std_logic_vector(3 downto 0) := (others => '0');
signal rxbuf_in : std_logic_vector(31 downto 0) := (others => '0');
signal rxbuf_wa : std_logic_vector(8 downto 0) := (others => '0');
signal rxbuf_ra : std_logic_vector(10 downto 0) := (others => '0');
signal rxbuf_wa_sync : std_logic_vector(3 downto 0) := (others => '0');
signal we_txbuf: std_logic := '0';
signal LRB_pause: std_logic := '0';
signal LRB_OT : std_logic_vector(8 downto 0) := (others => '0');
signal txbuf_do : std_logic_vector(35 downto 0) := (others => '0');
signal txbuf_wa : std_logic_vector(10 downto 0) := (others => '0');
signal txbuf_ra : std_logic_vector(8 downto 0) := (others => '0');
signal txbuf_wa_sync : std_logic_vector(3 downto 0) := (others => '0');
signal txbuf_wa_sync2 : std_logic_vector(3 downto 0) := (others => '0');
signal inc_txbuf_ra : std_logic := '0';
signal addr_i : std_logic_vector(15 downto 0) := (others => '0');
signal addr_str_i: std_logic := '0';
begin
vme_cycle <= vme_cycle_i;
addr <= addr_i;
addr_str <= addr_str_i;
mem_test <= mem_test_i;
w_data <= txbuf_do(31 downto 0);
we_byte <= txbuf_do(35 downto 32) when inc_txbuf_ra = '1' else x"0";
txbuf_ra(8 downto 4) <= "00000";
txbuf_wa(10 downto 6) <= "00000";
i_RXCLK : OBUFDS generic map(IOSTANDARD => "LVDS_25") port map (O => RXCLK_p, OB => RXCLK_n, I => RXCLK);
i_RXCLKddr : ODDR2
		port map (
      Q => RXCLK, -- 1-bit output data
      C0 => clk, -- 1-bit clock input
      C1 => clk180, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D0 => '1',   -- 1-bit data input (associated with C0)
      D1 => '0',   -- 1-bit data input (associated with C1)
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
g_VME_data: for i in 0 to 4 generate
	i_RXD : OBUFDS generic map(IOSTANDARD => "LVDS_25") port map (O => RXD_p(i), OB => RXD_n(i), I => RXD(i));
	i_RXDddr : ODDR2
		generic map(DDR_ALIGNMENT => "C1")
		port map (
      Q => RXD(i), -- 1-bit output data
      C0 => clk, -- 1-bit clock input
      C1 => clk180, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D0 => rx_data(2*i+0),   -- 1-bit data input (associated with C0)
      D1 => rx_data(2*i+1),   -- 1-bit data input (associated with C1)
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
--  i_TXD: ibufds generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33",IFD_DELAY_VALUE => "2") port map(i => TXD_p(i), ib => TXD_n(i), o => TXD(i));
  i_TXD: ibufds generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33") port map(i => TXD_p(i), ib => TXD_n(i), o => TXD(i));
	i_TXDddr : IDDR2
   generic map(DDR_ALIGNMENT => "C0")
   port map (
      Q0 => tx_datap(i), -- 1-bit output captured with C0 clock
      Q1 => tx_datap(5+i), -- 1-bit output captured with C1 clock
      C0 => vmeclk, -- 1-bit clock input
      C1 => not vmeclk, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D => TXD(i),   -- 1-bit data input 
      R => not clk_lock,    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
end generate;
tx_data <= tx_datap	when sim else not tx_datap(9) & tx_datap(8) & not tx_datap(7 downto 4) & tx_datap(3) & not tx_datap(2 downto 0);
i_txbuf : RAMB16BWE_S36_S9
   port map (
      DOA => txbuf_do(31 downto 0),      -- Port A 32-bit Data Output
      DOPA => txbuf_do(35 downto 32),    -- Port A 4-bit Parity Output
      ADDRA => txbuf_ra,  -- Port A 9-bit Address Input
      ADDRB => txbuf_wa,  -- Port B 11-bit Address Input
      CLKA => clk,    -- Port A 1-bit Clock
      CLKB => vmeclk,    -- Port B 1-bit Clock
      DIA => x"00000000",      -- Port A 32-bit Data Input
      DIB => tx_data(7 downto 0),      -- Port B 8-bit Data Input
      DIPA => x"0",    -- Port A 4-bit parity Input
      DIPB => tx_data(8 downto 8),    -- Port B 1-bit parity Input
      ENA => strobe,      -- Port A 1-bit RAM Enable Input
      ENB => we_txbuf,      -- Port B 1-bit RAM Enable Input
      SSRA => '0',    -- Port A 1-bit Synchronous Set/Reset Input
      SSRB => '0',    -- Port B 1-bit Synchronous Set/Reset Input
      WEA => x"0",      -- Port A 4-bit Write Enable Input
      WEB => '1'       -- Port B 1-bit Write Enable Input
   );
i_rxbuf : RAMB16BWE_S36_S9
   port map (
      DOB => rx_data(7 downto 0),      -- 32-bit B port data output
      ADDRA => rxbuf_wa,  -- 9-bit A port address input
      ADDRB => rxbuf_ra,  -- 11-bit B port address input
      CLKA => clk,    -- 1-bit A port clock input
      CLKB => clk180,    -- 1-bit B port clock input
      DIA => rxbuf_in,      -- 32-bit A port data input
      DIB => x"00",      -- 8-bit B port data input
      DIPA => x"0",    -- 4-bit  A port parity input
      DIPB => "0",    -- 1-bit  B port parity input
      ENA => strobe,      -- 1-bit  A port enable input
      ENB => '1',      -- 1-bit  B port enable input
      SSRA => '0',    -- 1-bit A port reset input
      SSRB => '0',    -- 1-bit B port reset input
      WEA => we_rxbuf,      -- 4-bit  A port Write Enable Input
      WEB => '0'       -- 1-bit  B port Write Enable Input
   );
rx_data(8) <= vme_cycle_i or mem_test_i;
rxbuf_in <= r_data when sim else not r_data;
we_rxbuf <= x"f" when r_data_val = '1' else x"0";
we_txbuf <= '1' when tx_data(9) = '1' or txbuf_wa(1 downto 0) /= "00" else '0';
process(vmeclk)
begin
  if(vmeclk'event and vmeclk = '1')then
--		TXD_q <= TXD;
--		if(sim)then
--			tx_data <= tx_data(3 downto 0) & TXD_q;
--		else
--			tx_data <= tx_data(3 downto 0) & not TXD_q(4) & TXD_q(3) & not TXD_q(2 downto 0);
--		end if;
--		if(we_txbuf = '1')then
--			we_txbuf <= '0';
--		elsif(tx_data(4) = '1' or txbuf_wa(1 downto 0) /= "00")then
--			we_txbuf <= '1';
--		end if;
		if(we_txbuf = '1')then
			txbuf_wa(1 downto 0) <= txbuf_wa(1 downto 0) + 1;
			if(txbuf_wa(1 downto 0) = "11")then
				txbuf_wa(2) <= not txbuf_wa(5) xor txbuf_wa(4) xor txbuf_wa(3);
				if(txbuf_wa(2) = '1')then
					txbuf_wa(3) <= not txbuf_wa(5) xor txbuf_wa(4);
				end if;
				if(txbuf_wa(3 downto 2) = "10")then
					txbuf_wa(4) <= not txbuf_wa(5);
				end if;
				if(txbuf_wa(3 downto 2) = "00")then
					txbuf_wa(5) <= txbuf_wa(4);
				end if;
			end if;
		end if;
  end if;
end process;
process(clk)
begin
  if(clk'event and clk = '1')then
    strobe <= not strobe;
    n_strobe <= strobe;
		if(strobe = '1')then
			if(vme_cycle_i = '0' and mem_test_i = '0')then
				rxbuf_wa <= (others => '0');
			elsif(r_data_val = '1')then
				rxbuf_wa(3 downto 0) <= rxbuf_wa(3 downto 0) + 1;
			end if;
			txbuf_wa_sync <= txbuf_wa(5 downto 2);
			txbuf_wa_sync2 <= txbuf_wa_sync;
			if(inc_txbuf_ra = '1' or txbuf_wa_sync2 = txbuf_ra(3 downto 0) or LRB_pause = '1')then
				inc_txbuf_ra <= '0';
			else
				inc_txbuf_ra <= '1';
			end if;
			if(mem_test_i = '1')then
				addr_i <= x"2000";
			elsif(inc_txbuf_ra = '1' and txbuf_do(35 downto 32) = x"0")then
				addr_i <= txbuf_do(15 downto 0);
			elsif(inc_addr = '1' or (inc_txbuf_ra = '1' and txbuf_do(35) = '1'))then
				addr_i(12 downto 0) <= addr_i(12 downto 0) + 1;
			end if;
			if(inc_txbuf_ra = '1' and txbuf_do(35 downto 32) = x"0")then
				vme_cycle_i <= txbuf_do(22) and not txbuf_do(21);
				mem_test_i <= txbuf_do(31);
				if(txbuf_do(31) = '1')then
					rd_length <= "1111";
				elsif(txbuf_do(17) = txbuf_do(16))then
					rd_length <= not txbuf_do(3 downto 0);
				else
					rd_length <= "0000";
				end if;
				vme_read <= txbuf_do(23);
			end if;
			if(inc_txbuf_ra = '1' and txbuf_do(35 downto 31) = "00000" and mem_test_i = '0')then
				addr_str_i <= '1';
			else
				addr_str_i <= '0';
			end if;
			if(inc_txbuf_ra = '1')then
				txbuf_ra(0) <= not txbuf_ra(3) xor txbuf_ra(2) xor txbuf_ra(1);
				if(txbuf_ra(0) = '1')then
					txbuf_ra(1) <= not txbuf_ra(3) xor txbuf_ra(2);
				end if;
				if(txbuf_ra(1 downto 0) = "10")then
					txbuf_ra(2) <= not txbuf_ra(3);
				end if;
				if(txbuf_ra(1 downto 0) = "00")then
					txbuf_ra(3) <= txbuf_ra(2);
				end if;
			end if;
			if(inc_txbuf_ra = '1' and addr_i(14) = '1' and addr_i(12 downto 10) /= "101")then
				LRB_pause <= '1';
			elsif(vme_cycle_i = '0' or or_reduce(LRB_ack) = '1' or LRB_OT(8) = '1')then
				LRB_pause <= '0';
			end if;
			if(LRB_pause = '0')then
				LRB_OT <= (others => '0');
			else
				LRB_OT <= LRB_OT + 1;
			end if;
		end if;
  end if;
end process;
process(clk180)
begin
  if(clk180'event and clk180 = '1')then
		rxbuf_wa_sync <= rxbuf_wa(3 downto 0);
		if(vme_cycle_i = '0' and mem_test_i = '0')then
			rxbuf_ra <= (others => '0');
			rx_data(9) <= '0';
		else
			if(rxbuf_wa_sync /= rxbuf_ra(5 downto 2))then
				rxbuf_ra(5 downto 0) <= rxbuf_ra(5 downto 0) + 1;
			end if;
			if(rxbuf_wa_sync /= rxbuf_ra(5 downto 2))then
				rx_data(9) <= '1';
			else
				rx_data(9) <= '0';
			end if;
		end if;
  end if;
end process;
end Behavioral;

